;----------------------------------------------------
; ***  plot contour with means on 2D-binned grid  ***
;----------------------------------------------------

PRO CONTOUR_MEANS,dist

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  COMMON selection, sel_models,sel_SEDs,sel_lines
  COMMON output, pswrite, datwrite
  COMMON window, Wlist

  if (Nmod EQ 0) then begin
    print,"*** ERROR:  read a database first!"
    RETURN
  endif  
  print,"plotting mean contours ..."
  print,"x-axis = """+xvar1+"/"+xvar2+""" log="+STRTRIM(STRING(xlog),2)  
  print,"y-axis = """+yvar1+"/"+yvar2+""" log="+STRTRIM(STRING(ylog),2)
  print,"z-axis = """+cname1+"/"+cname2+""" log="+STRTRIM(STRING(clog),2)
  if ((xvar1 EQ "none") OR (yvar1 EQ "none") OR (cname1 EQ "none")) then begin
    print,"*** ERROR:  define x-axis, y-axis, and colour first!"
    RETURN
  endif

  openw,1,"asave.xdent"
  printf,1,xvar1
  printf,1,xvar2
  printf,1,xlog
  printf,1,yvar1
  printf,1,yvar2
  printf,1,ylog
  printf,1,cname1
  printf,1,cname2
  printf,1,clog
  printf,1,xminval
  printf,1,xmaxval
  printf,1,yminval
  printf,1,ymaxval
  printf,1,zminval
  printf,1,zmaxval
  printf,1,cminval
  printf,1,cmaxval
  printf,1,ncolour
  printf,1,fvar1
  printf,1,fvar2
  printf,1,fvar3
  printf,1,fvar4
  printf,1,fmin1
  printf,1,fmax1
  printf,1,fmin2
  printf,1,fmax2
  printf,1,fmin3
  printf,1,fmax3
  printf,1,fmin4
  printf,1,fmax4 
  close,1

  ; --- get variables from names ---
  GET_VAR, xvar1, xxx, xtitel, xsel, dist
  GET_VAR, yvar1, yyy, ytitel, ysel, dist
  GET_VAR, cname1, ccc, ctitel, csel, dist
  sel = xsel
  sel(WHERE(ysel EQ 0)) = 0 
  sel(WHERE(csel EQ 0))=0
  if (xvar2 NE 'none') then begin
    GET_VAR, xvar2, xx2, x2titel, x2sel, dist
    if ((xvar1 EQ 'alpha_SED') AND (xvar2 EQ 'beta_abs')) then begin
      xxx = xxx-xx2
      xtitel = xtitel+" - "+x2titel
    endif else begin
      xxx = xxx/xx2
      xtitel = xtitel+" / "+x2titel
    endelse  
    sel(WHERE(x2sel EQ 0))=0 
    tmp=WHERE(xx2 EQ 0.0, count)
    if (xlog) then tmp=WHERE(xx2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
   endif  
  if (yvar2 NE 'none') then begin
    GET_VAR, yvar2, yy2, y2titel, y2sel, dist
    yyy = yyy/yy2
    sel(WHERE(y2sel EQ 0))=0 
    tmp=WHERE(yy2 EQ 0.0, count)
    if (ylog) then tmp=WHERE(yy2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
    ytitel = ytitel+" / "+y2titel
  endif      
  if (cname2 NE 'none') then begin
    GET_VAR, cname2, cc2, c2titel, c2sel, dist
    ccc = ccc/cc2
    sel(WHERE(c2sel EQ 0))=0 
    tmp=WHERE(cc2 EQ 0.0, count)
    if (clog) then tmp=WHERE(cc2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
    ctitel = ctitel+" / "+c2titel
  endif      

  if (xlog) then begin            ; de-select negative points if log
    tmp = WHERE(xxx LE 0.0, count)
    if (count GT 0) then sel(tmp)=0 
  endif  
  if (ylog) then begin
    tmp = WHERE(yyy LE 0.0, count)
    if (count GT 0) then sel(tmp)=0 
  endif  
  if (clog) then begin
    tmp = WHERE(ccc LE 0.0, count)
    if (count GT 0) then sel(tmp)=0 
  endif  

  ; --- filter model selection according to specified values ---

  if (fvar1 NE 'none') then begin
    GET_VAR, fvar1, filter1, dum1, dum2, dist
    if (fmin1 NE 'auto') then begin
      reads,fmin1,val
      ind = WHERE(filter1 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax1 NE 'auto') then begin
      reads,fmax1,val
      ind = WHERE(filter1 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar2 NE 'none') then begin
    GET_VAR, fvar2, filter2, dum1, dum2, dist
    if (fmin2 NE 'auto') then begin
      reads,fmin2,val
      ind = WHERE(filter2 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax2 NE 'auto') then begin
      reads,fmax2,val
      ind = WHERE(filter2 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar3 NE 'none') then begin
    GET_VAR, fvar3, filter3, dum1, dum2, dist
    if (fmin3 NE 'auto') then begin
      reads,fmin3,val
      ind = WHERE(filter3 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax3 NE 'auto') then begin
      reads,fmax3,val
      ind = WHERE(filter3 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar4 NE 'none') then begin
    GET_VAR, fvar4, filter4, dum1, dum2, dist
    if (fmin4 NE 'auto') then begin
      reads,fmin4,val
      ind = WHERE(filter4 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax4 NE 'auto') then begin
      reads,fmax4,val
      ind = WHERE(filter4 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (max(sel) LT 1) then begin
    print,"*** no points to be plotted according to this selection"
    return
  endif
  xx = xxx(WHERE(sel EQ 1))  
  yy = yyy(WHERE(sel EQ 1))
  cc = ccc(WHERE(sel EQ 1))  

  if (xlog) then begin
    xtitel = "log!L !N"+xtitel  
    xx = ALOG10(xx)
  endif  
  if (ylog) then begin
    ytitel = "log!L !N"+ytitel  
    yy = ALOG10(yy)
  endif  
  if (clog) then begin
    ctitel = "log!L !N"+ctitel  
    cc = ALOG10(cc)
  endif  

  NN=N_ELEMENTS(xx)

  dimensions = GET_SCREEN_SIZE(RESOLUTION=resolution)
  xstart=min([528,dimensions(0)-650-8])
  base = WIDGET_BASE(TITLE=STRTRIM(STRING(NN),2)+" "+gridNAME+" models",$
                     XOFFSET=xstart,YOFFSET=0, KILL_NOTIFY="PLOT_CLOSED")
  drawID = WIDGET_DRAW(base,RETAIN=2,XSIZE=650,YSIZE=950)
  WIDGET_CONTROL, drawID, /Realize
  WIDGET_CONTROL, drawID, Get_Value=wid
  WSET, wid
  DEVICE,DECOMPOSED=0
  for i=0,99 do begin
    if (Wlist(i) EQ 0) then begin
      Wlist(i) = base
      break
    endif
  endfor
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (ncolour EQ 1) then colors=[black]
  if (ncolour EQ 2) then colors=[red,black]
  if (ncolour EQ 3) then colors=[red,green,black]
  if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
  if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
  if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
  if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]

  x1=min(xx)
  x2=max(xx)
  y1=min(yy)
  y2=max(yy)
  xmin = x1-0.05*(x2-x1)
  xmax = x2+0.05*(x2-x1)
  ymin = y1-0.05*(y2-y1)
  ymax = y2+0.05*(y2-y1)
  if (xminval NE "auto") then begin
    reads,xminval,xmin
    if (xlog) then xmin=ALOG10(xmin)
  endif
  if (xmaxval NE "auto") then begin
    reads,xmaxval,xmax
    if (xlog) then xmax=ALOG10(xmax)
  endif
  if (yminval NE "auto") then begin
    reads,yminval,ymin
    if (ylog) then ymin=ALOG10(ymin)
  endif
  if (ymaxval NE "auto") then begin
    reads,ymaxval,ymax
    if (ylog) then ymax=ALOG10(ymax)
  endif
  if (xmax LE xmin) then begin
    xmin=xmin-0.5 
    xmax=xmin+0.5
  endif
  if (ymax LE ymin) then begin
    ymin=ymin-0.5 
    ymax=ymin+0.5
  endif
  
  bins = 30
  deltax = (xmax-xmin)/bins
  deltay = (ymax-ymin)/bins
  xmeans = dblarr(bins,bins)
  ymeans = dblarr(bins,bins)
  zmeans = dblarr(bins,bins)
  zsigma = dblarr(bins,bins)
  z1 =  9.d+99
  z2 = -9.d+99
  for ix=0,bins-1 do begin
    for iy=0,bins-1 do begin
      x1 = xmin + deltax*ix
      x2 = xmin + deltax*(ix+1)
      y1 = ymin + deltay*iy
      y2 = ymin + deltay*(iy+1)
      index = WHERE((xx GE x1) AND (xx LT x2) AND $
                    (yy GE y1) AND (yy LT y2), count)
      if (count GT 5) then begin     
        xvals = xx(index)
        yvals = yy(index)
        cvals = cc(index)
        xmeans(ix,iy) = MEAN(xvals)         ; minimum statistics required!
        ymeans(ix,iy) = MEAN(yvals)
        zmeans(ix,iy) = MEAN(cvals)
        zsigma(ix,iy) = STDDEV(cvals)
        z1=min([z1,zmeans(ix,iy)])
        z2=max([z2,zmeans(ix,iy)])
      endif else begin
        xmeans(ix,iy) = !VALUES.D_NAN       ; treated as "missing data"
        ymeans(ix,iy) = !VALUES.D_NAN
        zmeans(ix,iy) = !VALUES.D_NAN
        zsigma(ix,iy) = !VALUES.D_NAN
      endelse
      print,format='(I3,I3,I6," x=",E9.2," y=",E9.2,E11.2," +/-",E9.2)', $
            ix,iy,count,xmeans(ix,iy),ymeans(ix,iy),zmeans(ix,iy),zsigma(ix,iy)
    endfor
  endfor

  !P.MULTI=[0,1,2]
  !P.REGION = [-0.02,0.48,1.02,1.02]
  goodIndices = WHERE(Finite(xmeans))
  xtmp  = xmeans(goodIndices)
  ytmp  = ymeans(goodIndices)
  ztmp  = zmeans(goodIndices)
  Ndens = 5                      ; increase point resolution by factor
  Np    = (bins-1)*Ndens
  xplot = fltarr(Np+1,Np+1)
  yplot = fltarr(Np+1,Np+1)
  zplot = GRID_TPS(xtmp, ytmp, ztmp, NGRID=[Np+1,Np+1], $
                   START=[xmin,ymin], DELTA=[(xmax-xmin)/Np,(ymax-ymin)/Np])
  tmp   = SMOOTH(zplot,2*Ndens+1,/EDGE_TRUNCATE)
  zplot = tmp
  for i=0,Np do begin
    for j=0,Np do begin
      xplot(i,j) = xmin+i*(xmax-xmin)/Np
      yplot(i,j) = ymin+j*(ymax-ymin)/Np
      ix1=i/Ndens
      ix2=(i+Ndens-1)/Ndens
      iy1=j/Ndens
      iy2=(j+Ndens-1)/Ndens
      tmp=WHERE(FINITE(zmeans(ix1:ix2,iy1:iy2)),count)
      ;print,format='(2I3,2E10.2,6I3)',i,j,xplot(i,j),yplot(i,j),$
      ;                                ix1,ix2,iy1,iy2,count
      if (count EQ 0) then zplot(i,j)=!VALUES.D_NAN
    endfor
  endfor
  ;--- set min/max contour levels slightly inward of data range --- 
  zmin = z1+0.2*(z2-z1)
  zmax = z2-0.2*(z2-z1)
  if (cminval NE "auto") then begin
    reads,cminval,zmin
    if (clog) then zmin=ALOG10(zmin)
  endif
  if (cmaxval NE "auto") then begin
    reads,cmaxval,zmax
    if (clog) then zmax=ALOG10(zmax)
  endif
  if (zmax LE zmin) then zmin=zmax-0.01    
  clabel=strarr(ncolour) ;     for output 
  cval  =fltarr(ncolour) ; into 'nice_contour_means.dat'
  for j=0,ncolour-1 do begin
    zval = zmin+j*(zmax-zmin)/(ncolour-1)
    cval(j) = zval
    if (clog) then zval = 10.0^zval
    clabel(j) = STRING(format='(E7.1)',zval)  
  endfor 
  contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
           xstyle=1,ystyle=1,thick=2,charsize=1.6,$ 
           xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
           levels=cval,c_colors=colors,c_labels='',c_thick=2
  xpos = 0.96  
  ypos = 0.96
  xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=1.0,CHARSIZE=1.5,color=black
  ypos=ypos-0.02
  for j=0,ncolour-1 do begin
    xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=colors(j),$
           CHARSIZE=1.2,clabel(j)
    ypos=ypos-0.017
  endfor 

  ;------------------
  ;--- plot sigma ---
  ;------------------
  !P.REGION = [-0.02,-0.01,1.02,0.52]
  ztmp  = zsigma(goodIndices)
  zplot = GRID_TPS(xtmp, ytmp, ztmp, NGRID=[Np+1,Np+1], $
                   START=[xmin,ymin], DELTA=[(xmax-xmin)/Np,(ymax-ymin)/Np])
  tmp   = SMOOTH(zplot,2*Ndens+1,/EDGE_TRUNCATE)
  zplot = tmp
  for i=0,Np do begin
    for j=0,Np do begin
      ix1=i/Ndens
      ix2=(i+Ndens-1)/Ndens
      iy1=j/Ndens
      iy2=(j+Ndens-1)/Ndens
      tmp=WHERE(FINITE(zmeans(ix1:ix2,iy1:iy2)),count)
      if (count EQ 0) then zplot(i,j)=!VALUES.D_NAN
    endfor
  endfor
  sig_val=[0.0,0.1,0.2,0.5,1.0,1.5]
  sig_col=[black,magenta,blue,green,yellow,red]
  contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],/CELL_FILL,$
          xstyle=1,ystyle=1,thick=2,charsize=1.6,$
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          levels=sig_val,c_colors=sig_col,c_labels=''
  xpos = 0.96  
  ypos = 0.46
  xyouts,xpos,ypos,/normal,"sigma",ALIGNMENT=1.0,CHARSIZE=1.5,color=black
  ypos=ypos-0.02
  for j=1,5 do begin
    xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=sig_col(j),CHARSIZE=1.2,$
                STRING(format='(">",F6.1)',sig_val(j))
    ypos=ypos-0.017
  endfor 
  !P.MULTI = 0
  
  ;---------------------------------------------------------
  ;--- write data to file to allow personal 'nice' plots ---
  ;---------------------------------------------------------    

  if (datwrite) then begin
    filename = DIALOG_PICKFILE(/WRITE,FILE='myplot.dat',FILTER='*.dat')   
    if (STRPOS(filename,'.dat') EQ -1) then return
    openw,1,filename
    printf,1,"     NN = ",   NN,  FORMAT='(A10,I10)'
    printf,1,"ncolour = ",ncolour,FORMAT='(A10,I1)'
    printf,1,"   xmin = ",  xmin, FORMAT='(A10,E15.5)'
    printf,1,"   xmax = ",  xmax, FORMAT='(A10,E15.5)'
    printf,1," xtitel = ",xtitel, FORMAT='(A10,A40)'
    printf,1,"   ymin = ",  ymin, FORMAT='(A10,E15.5)'
    printf,1,"   ymax = ",  ymax, FORMAT='(A10,E15.5)'
    printf,1," ytitel = ",ytitel, FORMAT='(A10,A40)'
    printf,1," ctitel = ",ctitel, FORMAT='(A10,A30)'
    for i=0,ncolour-1 do begin
      printf,1,cval(i),clabel(i),  FORMAT='(E15.5,A40)'
    endfor
    printf,1,"         "
    printf,1,"x values","y values","c values",FORMAT='(3A15)'
    i=0L
    repeat begin
      printf,1,xx(i),yy(i),cc(i),FORMAT='(3E15.5)'
      i=i+1
    endrep until (i EQ NN)
    close,1  
    print,"... output written to "+STRTRIM(filename)+"."
     
    if (filename NE 'nice_contour_means.dat') then begin
      core=STRMID(filename,0,STRLEN(filename)-4) 
      ipos=STRPOS(core,'/',/REVERSE_SEARCH)
      if (ipos GT 0) then core=STRMID(core,ipos+1)
      file1='nice_contour_means.pro'
      file2=core+'.pro'
      openr,1,file1
      openw,2,file2
      line=' '
      for i=1,9999 do begin
        readf,1,line
        if (STRPOS(line,'myplot.dat') NE -1) then begin 
          line='  openr,1,'''+filename+'''' 
        endif
        if (STRPOS(line,'myplot.ps') NE -1) then begin 
          line='  psfile ='''+core+'.ps'''
        endif    
        printf,2,line
        if (STRTRIM(line,2) EQ 'END') then break
      endfor
      close,1
      close,2
      print,"... created "+file2+"."
    endif

    print,"----------------------------------------------------------------"
    print,"***  Next, type .r "+core+" to produce a nice ps-plot.       ***"
    print,"***  Feel free to modify "+file2+" to optimize your plot. ***"
    print,"----------------------------------------------------------------"
    print
  
  endif

END
