
;-----------------------------------------
; ***  search for best fitting models  ***
;-----------------------------------------
PRO FIT_OBS, dist

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs,Flineobs,sigmaFnu,sigmaFl,bemcont,bemline,$
               LineName, LineFlux

  COMMON selection, sel_models,sel_SEDs,sel_lines
  COMMON fits, ID_best,gas_best,incl1_best,incl2_best,chi_best 
  COMMON SEDplot, Nplotted,Fmin,Fmax 

  print,"fitting models to observational data ..."
  
  Nplotted = 0
  for i=0,9 do chi_best(i)=1.E+99
  kbest=intarr(Nincl1)
  for k=0,Nincl1-1 do begin
    qbest=9.e+29
    for j=0,Nincl2-1 do begin
      qual=ABS(incl1(k)-incl2(j))
      if (qual LT qbest) then begin
        qbest=qual
        kbest(k)=j
      endif
    endfor
    ;print,k,incl1(k),kbest(k),incl2(kbest(k))
  endfor
  
  i=0L
  sel_lines1 = intarr(Nmod,Ngas,Nincl1)
  repeat begin
    for j=0,Ngas-1 do begin
      for k=0,Nincl1-1 do begin
        sel_lines1(i,j,k)=sel_lines(i,j,kbest(k))       
      endfor
    endfor
    i=i+1
  endrep until (i EQ Nmod)

  if ((Ncont EQ 0) AND (Nline EQ 0)) then begin
    print, "*** first load observations! ***"
    return
  endif

  igas1 = 1
  igas2 = 1
  if (Nline GT 0) then begin                   ; loop limits for igas 
    igas1=0
    igas2=Ngas-1
  endif

  lFcont_obs = ALOG10(Fnuobs)                  ; log(observed cont flux)
  llam_model = ALOG10(lamcont(*))              ; log(lambda_model)
  lFline_obs = ALOG10(Flineobs)                ; log(observed line flux)

  id=0L
  repeat begin                       ; loop over modelID
    for i=0,Nincl1-1 do begin        ; loop over continuum inclinations

      chi_cont  = 0.0
      ichi_cont = 0

      if ((Ncont GE 1)&&(sel_SEDs(id,i) GT 0)) then begin

        lFcont_model = ALOG10(Fcont(id,i,*)*(140.0/dist)^2)   ; log(Fnu_model)
        for j=0,Ncont-1 do begin

          ;--- spline interpolation of model Flux around lamobs 
          ltest        = ALOG10(lamobs(j)*(0.95+0.1*FINDGEN(20)/19))
          lFnu_model   = INTERPOL(lFcont_model,llam_model,ltest,/SPLINE)

          ;--- take best value in small lam-interval ---
          lFmodel = 0.0
          qbest   = 9.e+99
          for k=0,19 do begin
            qual = ABS(lFnu_model(k)-lFcont_obs(j))
            if (qual LT qbest) then begin
              lFmodel = lFnu_model(k)
              qbest   = qual
            endif
          endfor
  
          sigma = sigmaFnu(j)
          bem   = STRTRIM(bemcont(j),2)
          if (bem EQ "ok") then begin
            sigma = max([sigma,0.1*Fnuobs(j)])            ; at least 10% error
            lsig  = ALOG10(1.0+sigma/Fnuobs(j))           ; sigma in log-space
            chi_cont   = chi_cont + ((lFmodel - lFcont_obs(j))/lsig)^2
            ichi_cont  = ichi_cont + 1
          endif  
          if (bem EQ "ul") then begin
            chi_cont   = chi_cont + ((10.0^lFmodel)/sigma)^2
            ichi_cont  = ichi_cont + 1
          endif
        endfor
      endif

      for igas=igas1,igas2 do begin  ; loop over igas

        chi_line  = 0.0
        ichi_line = 0

        if (Nline GE 1) then begin 

          if (sel_lines1(id,igas,i) AND (Ncont GE 1) AND sel_SEDs(id,i)) then begin

            for j=0,Nline-1 do begin

              ind = WHERE(strpos(LineName,linenameobs(j)) ge 0,count) 
              if (count LE 0) then begin
                print,"*** linename ",linenameobs(j)," not found."  
                stop
              endif    
              Fline_model  = LineFlux(ind,id,igas,kbest(i))
              Fline_model  = Fline_model*(140.0/dist)^2
              lFline_model = ALOG10(Fline_model)        ; log(model line flux)
              sigma = sigmaFl(j)
              bem   = STRTRIM(bemline(j),2)
              if (bem EQ "ok") then begin
                sigma = max([sigma,0.1*Flineobs(j)])    ; at least 10% error
                lsig  = ALOG10(1.0+sigma/Flineobs(j))   ; sigma in log-space
                chi_line  = chi_line + ((lFline_model - lFline_obs(j))/lsig)^2
                ichi_line = ichi_line + 1
              endif  
              if (bem EQ "ul") then begin
                chi_line   = chi_line + (Fline_model/sigma)^2
                ichi_line  = ichi_line + 1
              endif

            endfor

          endif else begin
            chi_line = 1.E+99      ; do not choose this model
          endelse

        endif

        if (((Ncont EQ 0) OR (ichi_cont GT 0)) AND $            ; otherwise not selected
            ((Nline EQ 0) OR (ichi_line GT 0))) then begin      ; /nothing found
  
          chi = SQRT((chi_cont+chi_line)/(ichi_cont+ichi_line))        

          if (chi LT chi_best(9)) then begin
            chi_best(9)=chi
            ID_best(9)=id
            gas_best(9)=igas
            qbest=99.9
            for ii=0,Nincl2-1 do begin
              qual=ABS(incl2(ii)-incl1(i))
              if (qual LT qbest) then begin
                qbest=qual
                i2best=ii
              endif
            endfor
            incl1_best(9)=i
            incl2_best(9)=i2best          
            for j=8,0,-1 do begin
              if (chi_best(j) LE chi_best(j+1)) then break
              qtmp=chi_best(j)
              Ntmp=ID_best(j)
              gtmp=gas_best(j)
              itmp1=incl1_best(j)
              itmp2=incl2_best(j)
              chi_best(j)=chi_best(j+1)
              ID_best(j)=ID_best(j+1)
              gas_best(j)=gas_best(j+1)
              incl1_best(j)=incl1_best(j+1)
              incl2_best(j)=incl2_best(j+1)
              chi_best(j+1)=qtmp
              ID_best(j+1)=Ntmp
              gas_best(j+1)=gtmp
              incl1_best(j+1)=itmp1
              incl2_best(j+1)=itmp2
            endfor
          endif
        endif

      endfor      
    endfor
    id=id+1
  endrep until (id EQ Nmod)
  
  ;print, SIZE(sel_lines,/DIMENSIONS),SIZE(sel_lines1,/DIMENSIONS)
  ;print, sel_lines(882,*,0), sel_lines1(882,*,0)
  ;---------------------------------------
  ; ***  print and select best models  ***
  ;---------------------------------------
  sel_models(*,*)=0
  sel_SEDs(*,*)=0
  sel_lines(*,*,*)=0
  seltext=WIDGET_INFO(combo_dustgas,/COMBOBOX_GETTEXT)
  for j=0,9 do begin
    print,format='("modelID=",I5," igas=",I2," incl=",F5.1," /",F5.1,"  chi=",F7.4)', $
      ID_best(j)+1,gas_best(j)+1,incl1(incl1_best(j)),incl2(incl2_best(j)),$
      chi_best(j)
    id=ID_best(j)
    if (id EQ -1) then break
    tmp=Mdust(id,*)
    gas_sel=(WHERE(tmp GT 0.0))
    ;---  if dust/gas is selected ... ---
    if (seltext NE 'all') then begin
      reads,seltext,val
      ;print,"selection dust/gas    =",val
      tmp=dust_to_gas(id,*)
      gas_sel=WHERE(ABS(tmp/val-1.0) LT 0.01)
    endif
    if (Nline LT 1.0) then begin
      sel_models(id,gas_sel)=1
      sel_SEDs(id,incl1_best(j))=1
      sel_lines(id,gas_sel,incl2_best(j))=1
    endif else begin  
      sel_models(id,gas_best(j))=1
      sel_SEDs(id,incl1_best(j))=1
      sel_lines(id,gas_best(j),incl2_best(j))=1
    endelse
  endfor
  sel_lines(WHERE(~FINITE(LineFlux(0,*,*,*))))=0
  dum1 = WHERE(sel_models EQ 1, count)
  print, count," disk models selected"
  dum1 = WHERE(sel_SEDs EQ 1, count)
  print, count," SEDs selected"
  dum1 = WHERE(sel_lines EQ 1, count)

  ;print, SIZE(sel_lines,/DIMENSIONS),SIZE(sel_lines1,/DIMENSIONS)
  ;print, sel_lines(882,*,0), sel_lines1(882,*,0)

  print, count," line fluxes selected"
  print,format='("best fitting model ID=",I5," @ dist=",F7.1,", incl=",F5.1)',$
        ID_best(0)+1,dist,incl1(incl1_best(0))

END
