

;-----------------------------------
; ***  print all about model id  ***
;-----------------------------------
PRO INFO_MODEL, id,igas,dist

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline,$
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  sep='-----------------------------------------------------'
  print,sep
  print," model,gas        = ",id+1,igas+1
  print,sep
  i = id
  j = igas
  print,"     Mstar [Msun] = ",ParaVal(WHERE(strpos(ParaName,'Mstar')   GE 0),i,j)
  print,"       age [Myr]  = ",age(i,j)
  print,"      Teff [K]    = ",ParaVal(WHERE(strpos(ParaName,'Teff')    GE 0),i,j)
  print,"     Lstar [Lsun] = ",ParaVal(WHERE(strpos(ParaName,'Lstar')   GE 0),i,j)
  print,"       fUV [-]    = ",ParaVal(WHERE(strpos(ParaName,'fUV')     GE 0),i,j)
  print,"      Mgas [Msun] = ",ParaVal(WHERE(strpos(ParaName,'Mgas')    GE 0),i,j)
  print,"     Mdust [Msun] = ",Mdust(i,j)
  print,"  dust/gas [-]    = ",ParaVal(WHERE(strpos(ParaName,'dust/gas')GE 0),i,j)
  print,"       Rin [AU]   = ",RinSave(i,j)
  print,"      Rout [AU]   = ",ParaVal(WHERE(strpos(ParaName,'Rout')    GE 0),i,j)
  print,"   epsilon [-]    = ",ParaVal(WHERE(strpos(ParaName,'epsilon') GE 0),i,j)
  print,"        H0 [AU]   = ",ParaVal(WHERE(strpos(ParaName,'H0')      GE 0),i,j)
  print,"      beta [-]    = ",ParaVal(WHERE(strpos(ParaName,'beta')    GE 0),i,j)
  print,"    settle [-]    = ",ParaVal(WHERE(strpos(ParaName,'settle')  GE 0),i,j)
  print,"      amin [mic]  = ",ParaVal(WHERE(strpos(ParaName,'amin')    GE 0),i,j)
  print,"      amax [mic]  = ",ParaVal(WHERE(strpos(ParaName,'amax')    GE 0),i,j)
  if (basenr ne 2) then print,"      apow [-]    = ",ParaVal(WHERE(strpos(ParaName,'apow')    GE 0),i,j)
  dfac = (140.0/dist)^2
  sel  = [10,2,5,7,9]
  if (basenr EQ 1) then sel = [0,1,2,3,4] 
  if (basenr EQ 3) then sel = [0,1,2,3,4] 
  print," SED  lam[mic] Fnu[Jy] @ dist[pc]=",dist
  print,format='(A12,99(F8.1))',"incl[deg]",incl1(sel)
  lamp = [1.0,10.0,100,1000]
  for k=0,3 do begin
    il = WHERE(ABS(lamcont-lamp(k)) EQ MIN(ABS(lamcont-lamp(k)))) 
    print,format='(F12.2,99(E8.1))',lamcont(il),Fcont(id,sel,il)*dfac
  endfor
  print,format='(" alpha-SED =",99(F6.3,2x))',alphaSED(id,sel)
  print,format='("  beta-abs =",F6.3)',beta_abs(i,j)
  print," Line Fluxes [W/m^2]   @ dist[pc]=",dist 
  print,format='(A12,99(F8.1))',"incl[deg]",incl2(*)
  ind = WHERE(strpos(LineName,"OI_63") GE 0)
  print,format='(A12,99(E8.1))'," OI   63",LineFlux(ind,id,igas,*)*dfac
  ind = WHERE(strpos(LineName,"OI_145") GE 0)
  print,format='(A12,99(E8.1))'," OI  145",LineFlux(ind,id,igas,*)*dfac
  ind = WHERE(strpos(LineName,"CII_157") GE 0)
  print,format='(A12,99(E8.1))'," CII 157",LineFlux(ind,id,igas,*)*dfac
  ind = WHERE(strpos(LineName,"CO_867") GE 0)
  print,format='(A12,99(E8.1))'," CO 3->2",LineFlux(ind,id,igas,*)*dfac
  ind = WHERE(strpos(LineName,"o-H2O_538") GE 0)
  print,format='(A12,99(E8.1))',"oH2O 538",LineFlux(ind,id,igas,*)*dfac
  print,sep
  print
END
