
;----------------------------------
; ***  load observational data  ***
;----------------------------------
PRO LOAD_OBSERVATIONS, filename,Nobs,Ncont,Nline,lamobs,Fnuobs,$
                       linenameobs, Flineobs, $
                       sigmaFnu, sigmaFl, bemcont, bemline
  tmp = 'bla'  
  tmp1 = 'blabla '
  lineval = ' '
  val = 0
  Nobs  = 0
  Ncont = 0
  Nline = 0
  openr,1,filename
  readf,1,val
  readf,1,tmp

  print,"----------------------------------------------------"
  print,"  lambda[mic]      Fnu[Jy]   sigmaFnu[Jy]     remark"
  Ncont    = val  
  Fnuobs   = fltarr(Ncont)
  lamobs   = fltarr(Ncont)
  sigmaFnu = fltarr(Ncont)
  bemcont  = strarr(Ncont)
  sigmaFnu(*) = 0.0
  bemcont(*)  = ''
  for i=0,Ncont-1 do begin
    readf,1,tmp
    contdata = STRSPLIT(tmp,/EXTRACT,COUNT=k)
    lamobs(i)   = STRTRIM(contdata(0),2)
    Fnuobs(i)   = STRTRIM(contdata(1),2)
    sigmaFnu(i) = STRTRIM(contdata(2),2)
    bemcont(i)  = STRTRIM(contdata(3),2)
    print,lamobs(i),Fnuobs(i),sigmaFnu(i),"       ",bemcont(i)
  endfor

  if (EOF(1) EQ 1) then begin
    close,1
    Nline = 0  
    Fline = 0.0
    Nobs = Ncont
    print,"... loaded ",Ncont," continuum points +",Nline," line fluxes."
    return
  endif

  readf,1,Nline

  if (Nline EQ 0) then begin
    close,1
    Nline = 0  
    Fline = 0.0
    Nobs = Ncont
    print,"... loaded ",Ncont," continuum points +",Nline," line fluxes."
    return
  endif

  readf,1,tmp
  linenameobs = strarr(Nline)
  Flineobs    = fltarr(Nline)
  sigmaFl     = fltarr(Nline)
  bemline     = strarr(Nline)
  sigmaFl(*)  = 0.0
  bemline(*)  = ''

  linedata = STRSPLIT(tmp,/EXTRACT,COUNT=k)
  print,"----------------------------------------------------"
  print,"    line   Fline[W/m^2]     sigmaFl[W/m^2]    remark"
  for i=0,Nline-1 do begin
    readf,1,tmp
    linedata = STRSPLIT(tmp,/EXTRACT,COUNT=k)
    linenameobs(i) = STRTRIM(linedata(0),2)
    Flineobs(i)    = STRTRIM(linedata(1),2)
    sigmaFl(i)     = STRTRIM(linedata(2),2)
    bemline(i)     = STRTRIM(linedata(3),2)
    print,format='(A8,E14.5,E17.5,A9)',$
          linenameobs(i),Flineobs(i),sigmaFl(i),bemline(i)
  endfor
  close,1
  Nobs = Ncont + Nline
  print,"----------------------------------------------------"
  print,"... loaded ",Ncont," continuum fluxes and ",Nline," line fluxes."

END
