  ;--------------------------------------------------------
  ;--- IDL macro for creating ps-plot from xDENT output ---
  ;--------------------------------------------------------

  openr,1,'myplot.dat'
  psfile ='myplot.ps'
  tmp = '     '
  xtitel = '   ' & ytitel = '   ' & ctitel = '   '
  
  readf,1, tmp, NN,     FORMAT='(A10,I10)'
  readf,1, tmp,ncolour, FORMAT='(A10,I1)'
  readf,1, tmp, xmin,   FORMAT='(A10,E15.5)'
  readf,1, tmp, xmax,   FORMAT='(A10,E15.5)'
  readf,1, tmp, xtitel, FORMAT='(A10,A40)'
  readf,1, tmp, ymin,   FORMAT='(A10,E15.5)'
  readf,1, tmp, ymax,   FORMAT='(A10,E15.5)'
  readf,1, tmp, ytitel, FORMAT='(A10,A40)'
  readf,1, tmp, ctitel, FORMAT='(A10,A40)'
  xtitel=strtrim(xtitel,2)
  ytitel=strtrim(ytitel,2)
  ctitel=strtrim(ctitel,2)

  val    = fltarr(3)
  val1   = '   '
  val2   = '   '
  xx     = fltarr(NN)
  yy     = fltarr(NN)
  cc     = intarr(NN)
  cval   = fltarr(ncolour)
  clabel = strarr(ncolour)
  for i=0,ncolour-1 do begin
    readf,1,val1,val2, FORMAT='(E15.5,A40)'
    cval(i)   = val1
    clabel(i) = STRTRIM(val2,2)
  endfor
  readf,1, tmp
  readf,1, tmp
  j=0L
  repeat begin
    readf,1,val
    xx(j) = val(0)
    yy(j) = val(1)
    cc(j) = val(2)
    j=j+1
  endrep until (j EQ NN)
  close,1

  x1=17.0
  x2=13.0
  x3=1.0
  x4=1.0
  pos=[0.15,0.11,0.985,0.98]
  SET_PLOT, 'ps'
  DEVICE, filename=psfile
  DEVICE, xsize=x1,ysize=x2,xoffset=x3,yoffset=x4,/color
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (ncolour EQ 1) then colors=[black]
  if (ncolour EQ 2) then colors=[red,black]
  if (ncolour EQ 3) then colors=[red,green,black]
  if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
  if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
  if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
  if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]

  bins = 30
  deltax = (xmax-xmin)/bins
  deltay = (ymax-ymin)/bins
  xmeans = dblarr(bins,bins)
  ymeans = dblarr(bins,bins)
  zmeans = dblarr(bins,bins)
  zsigma = dblarr(bins,bins)
  z1 =  9.d+99
  z2 = -9.d+99
  for ix=0,bins-1 do begin
    for iy=0,bins-1 do begin
      x1 = xmin + deltax*ix
      x2 = xmin + deltax*(ix+1)
      y1 = ymin + deltay*iy
      y2 = ymin + deltay*(iy+1)
      index = WHERE((xx GE x1) AND (xx LT x2) AND $
                    (yy GE y1) AND (yy LT y2), count)
      if (count GT 5) then begin     
        xvals = xx(index)
        yvals = yy(index)
        cvals = cc(index)
        xmeans(ix,iy) = MEAN(xvals)         ; minimum statistics required!
        ymeans(ix,iy) = MEAN(yvals)
        zmeans(ix,iy) = MEAN(cvals)
        zsigma(ix,iy) = STDDEV(cvals)
        z1=min([z1,zmeans(ix,iy)])
        z2=max([z2,zmeans(ix,iy)])
      endif else begin
        xmeans(ix,iy) = !VALUES.D_NAN       ; treated as "missing data"
        ymeans(ix,iy) = !VALUES.D_NAN
        zmeans(ix,iy) = !VALUES.D_NAN
        zsigma(ix,iy) = !VALUES.D_NAN
      endelse
      print,format='(I3,I3,I6," x=",E9.2," y=",E9.2,E11.2," +/-",E9.2)', $
            ix,iy,count,xmeans(ix,iy),ymeans(ix,iy),zmeans(ix,iy),zsigma(ix,iy)
    endfor
  endfor

  ;---------------------
  ;--- original data ---
  ;---------------------
  pp = [0.15,0.11,0.985,0.98]
  goodIndices = WHERE(Finite(xmeans))
  xtmp  = xmeans(goodIndices)
  ytmp  = ymeans(goodIndices)
  ztmp  = zmeans(goodIndices)
  Ndens = 5                      ; increase point resolution by factor
  Np    = (bins-1)*Ndens
  xplot = fltarr(Np+1,Np+1)
  yplot = fltarr(Np+1,Np+1)
  zplot = GRID_TPS(xtmp, ytmp, ztmp, NGRID=[Np+1,Np+1], $
                   START=[xmin,ymin], DELTA=[(xmax-xmin)/Np,(ymax-ymin)/Np])
  zsmooth = SMOOTH(zplot,2*Ndens+1,/EDGE_TRUNCATE)
  for i=0,Np do begin
    for j=0,Np do begin
      xplot(i,j) = xmin+i*(xmax-xmin)/Np
      yplot(i,j) = ymin+j*(ymax-ymin)/Np
      ix1=i/Ndens
      ix2=(i+Ndens-1)/Ndens
      iy1=j/Ndens
      iy2=(j+Ndens-1)/Ndens
      tmp=WHERE(FINITE(zmeans(ix1:ix2,iy1:iy2)),count)
      ;print,format='(2I3,2E10.2,6I3)',i,j,xplot(i,j),yplot(i,j),$
      ;                                ix1,ix2,iy1,iy2,count
      if (count EQ 0) then zplot(i,j)=!VALUES.D_NAN
      if (count EQ 0) then zsmooth(i,j)=!VALUES.D_NAN
    endfor
  endfor
  contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
           xstyle=1,ystyle=1,thick=2,charsize=1.3,position=pp,$ 
           xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
           levels=cval,c_colors=colors,c_labels='',c_thick=3
  xpos = 0.96  
  ypos = 0.92
  xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=1.0,CHARSIZE=1.5,color=black
  ypos=ypos-0.04
  for j=0,ncolour-1 do begin
    xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=colors(j),CHARSIZE=1.2,$
                clabel(j)
    ypos=ypos-0.03
  endfor 

  ;------------------------
  ;--- smoothed version ---
  ;------------------------
  contour, zsmooth,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
           xstyle=1,ystyle=1,thick=2,charsize=1.3,position=pp,$ 
           xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
           levels=cval,c_colors=colors,c_labels='',c_thick=3
  xpos = 0.96  
  ypos = 0.92
  xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=1.0,CHARSIZE=1.5,color=black
  ypos=ypos-0.04
  for j=0,ncolour-1 do begin
    xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=colors(j),CHARSIZE=1.2,$
                clabel(j)
    ypos=ypos-0.03
  endfor 

  ;------------------
  ;--- plot sigma ---
  ;------------------
  ztmp  = zsigma(goodIndices)
  zplot = GRID_TPS(xtmp, ytmp, ztmp, NGRID=[Np+1,Np+1], $
                   START=[xmin,ymin], DELTA=[(xmax-xmin)/Np,(ymax-ymin)/Np])
  tmp   = SMOOTH(zplot,2*Ndens+1,/EDGE_TRUNCATE)
  zplot = tmp
  for i=0,Np do begin
    for j=0,Np do begin
      ix1=i/Ndens
      ix2=(i+Ndens-1)/Ndens
      iy1=j/Ndens
      iy2=(j+Ndens-1)/Ndens
      tmp=WHERE(FINITE(zmeans(ix1:ix2,iy1:iy2)),count)
      if (count EQ 0) then zplot(i,j)=!VALUES.D_NAN
    endfor
  endfor
  sig_val=[0.0,0.1,0.2,0.5,1.0,1.5]
  sig_col=[black,magenta,blue,green,yellow,red]
  contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,thick=2,position=pp,charsize=1.3,$
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          /CELL_FILL,levels=sig_val,c_colors=sig_col,c_labels=''
  xpos = 0.96  
  ypos = 0.92
  xyouts,xpos,ypos,/normal,"sigma",ALIGNMENT=1.0,CHARSIZE=1.5,color=black
  ypos=ypos-0.04
  for j=1,5 do begin
    xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=sig_col(j),CHARSIZE=1.2,$
                STRING(format='(">",F6.1)',sig_val(j))
    ypos=ypos-0.03
  endfor 

  DEVICE,/close
  SET_PLOT, 'x'
  print,'... ps-output written to '+psfile
  
END
