  ;--------------------------------------------------------
  ;--- IDL macro for creating ps-plot from xDENT output ---
  ;--------------------------------------------------------

  openr,1,'myplot.dat'
  psfile ='myplot.ps'
  tmp = '     '
  xtitel = '   ' & ytitel = '   ' & ctitel = '   '
  
  readf,1, tmp, NN,     FORMAT='(A10,I10)'
  readf,1, tmp,ncolour, FORMAT='(A10,I1)'
  readf,1, tmp, xmin,   FORMAT='(A10,E15.5)'
  readf,1, tmp, xmax,   FORMAT='(A10,E15.5)'
  readf,1, tmp, xtitel, FORMAT='(A10,A40)'
  readf,1, tmp, ymin,   FORMAT='(A10,E15.5)'
  readf,1, tmp, ymax,   FORMAT='(A10,E15.5)'
  readf,1, tmp, ytitel, FORMAT='(A10,A40)'
  readf,1, tmp, zmin,   FORMAT='(A10,E15.5)'
  readf,1, tmp, zmax,   FORMAT='(A10,E15.5)'
  readf,1, tmp, ctitel, FORMAT='(A10,A40)'
  xtitel=strtrim(xtitel,2)
  ytitel=strtrim(ytitel,2)
  ctitel=strtrim(ctitel,2)
  farben = (ctitel NE "nix")

  val    = fltarr(3)
  val1   = '   '
  val2   = '   '
  xx     = fltarr(NN)
  yy     = fltarr(NN)
  cc     = intarr(NN)
  cval   = fltarr(ncolour)
  clabel = strarr(ncolour)
  for i=0,ncolour-1 do begin
    readf,1,val1,val2, FORMAT='(E15.5,A40)'
    cval(i)   = val1
    clabel(i) = STRTRIM(val2,2)
  endfor
  readf,1, tmp
  readf,1, tmp
  j=0L
  repeat begin
    readf,1,val
    xx(j) = val(0)
    yy(j) = val(1)
    cc(j) = val(2)
    j=j+1
  endrep until (j EQ NN)
  close,1

  x1=17.0
  x2=13.0
  x3=1.0
  x4=1.0
  pos=[0.15,0.12,0.985,0.98]
  SET_PLOT, 'ps'
  DEVICE, filename=psfile
  DEVICE, xsize=x1,ysize=x2,xoffset=x3,yoffset=x4,/color
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (ncolour EQ 1) then colors=[black]
  if (ncolour EQ 2) then colors=[red,black]
  if (ncolour EQ 3) then colors=[red,green,black]
  if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
  if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
  if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
  if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]

  bins = 20
  xmeans = dblarr(bins,bins)
  ymeans = dblarr(bins,bins)
  zmeans = dblarr(bins,bins,8)
  deltax = (xmax-xmin)/bins
  deltay = (ymax-ymin)/bins
  deltaz = (zmax-zmin)/ncolour
  nx = FLOOR((xx-xmin)/(xmax-xmin)*(bins-0.001))
  ny = FLOOR((yy-ymin)/(ymax-ymin)*(bins-0.001))

  for ix=0,bins-1 do begin
    for iy=0,bins-1 do begin
      index = WHERE((nx EQ ix) AND (ny EQ iy), count)
      if (count EQ 0) then begin     
        xmeans(ix,iy)   = !VALUES.D_NAN       ; treated as "missing data"
        ymeans(ix,iy)   = !VALUES.D_NAN
        zmeans(ix,iy,*) = !VALUES.D_NAN
      endif else begin
        xvals = xx(index)
        yvals = yy(index)
        xmeans(ix,iy) = MEAN(xvals)
        ymeans(ix,iy) = MEAN(yvals)
        zmeans(ix,iy,0) = count
        if (farben) then begin
          cvals = cc(index)  
          nc = FLOOR((cvals-zmin)/(zmax-zmin)*(ncolour-0.001))
          for j=0,ncolour-1 do begin
            index = WHERE(nc EQ j, count)
            zmeans(ix,iy,j) = count
            ;print,j,z1,z2,count
          endfor
        endif  
      endelse  
      print,format='(I3,I3," x=",E9.2," y=",E9.2,4I9)', $
            ix,iy,xmeans(ix,iy),ymeans(ix,iy),zmeans(ix,iy,0:3)
    endfor
  endfor

  goodIndices = WHERE(Finite(xmeans))
  xtmp  = xmeans(goodIndices)
  ytmp  = ymeans(goodIndices)
  Ndens = 5                 ; increase point resolution by factor
  Np    = (bins-1)*Ndens
  xplot = fltarr(Np+1,Np+1)
  yplot = fltarr(Np+1,Np+1)
  xpos = 0.94    ; ~0.25 for l.h.s. legend
  ypos = 0.92
  if (farben) then begin
    ;------ colour-selected sub-groups ------ 
    first_time = 1
    for j=0,ncolour-1 do begin
      ctmp = zmeans(*,*,j)   
      goodIndices = WHERE(Finite(ctmp))
      ztmp  = ctmp(goodIndices)
      zplot = GRID_TPS(xtmp, ytmp, ztmp, NGRID=[Np+1,Np+1], $
                   START=[xmin,ymin], DELTA=[(xmax-xmin)/Np,(ymax-ymin)/Np])
      zplot = SMOOTH(zplot,2*Ndens+1,/EDGE_TRUNCATE)
      Nmax = 0.0
      for ix=0,Np do begin
        for iy=0,Np do begin
          xplot(ix,iy) = xmin+ix*(xmax-xmin)/Np
          yplot(ix,iy) = ymin+iy*(ymax-ymin)/Np
          ix1=ix/Ndens
          ix2=(ix+Ndens-1)/Ndens
          iy1=iy/Ndens
          iy2=(iy+Ndens-1)/Ndens
          if (zplot(ix,iy) GT 0.0) then Nmax = MAX([Nmax,zplot(ix,iy)])
          tmp=WHERE(FINITE(xmeans(ix1:ix2,iy1:iy2)),count)
          if (count EQ 0) then zplot(ix,iy)=0.0  ;!VALUES.D_NAN
        endfor
      endfor
      if (Nmax LT 10) then goto,jump1 
      ;--- search for cbest-contour that encircles 66% of the models ---
      cval = [0.0,0.01,0.03,0.1,0.2,0.3,0.45,0.6,0.75,0.9,0.99,0.999]*Nmax
      pval = cval
      psearch = 0.666667
      for i=0,N_ELEMENTS(cval)-1 do begin
        ind = WHERE(zplot GT cval(i),count)
        if (count EQ 0) then begin
          pval(i) = 0.0
        endif else begin  
          ztmp = zplot(ind)
          Nsum = 0.0
          for k=0,count-1 do begin
            Nsum = Nsum + ztmp(k)
          endfor  
          if (i EQ 0) then Ntot=Nsum
          pval(i) = Nsum/Ntot
        endelse  
        print,cval(i)/Nmax,pval(i)
      endfor  
      cbest = INTERPOL(cval,pval,psearch,/spline)
      print,"==>",cbest/Nmax      
      if (first_time) then begin
        contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
           xstyle=1,ystyle=1,thick=2,charsize=1.3,position=pos,$ 
           xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
           levels=cbest,c_colors=colors(j),c_labels='',c_thick=2
        xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=1.0,CHARSIZE=1.3,color=black
        ypos = ypos-0.04
        first_time = 0
      endif else begin        
        ;wait,2.0  
        contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
           xstyle=1,ystyle=1,thick=2,charsize=1.3,/noerase,position=pos,$ 
           xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
           levels=cbest,c_colors=colors(j),c_labels='',c_thick=2
      endelse  
      xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=colors(j),$
           CHARSIZE=1.0,clabel(j)
      ypos=ypos-0.03
      jump1:
    endfor  
  endif else begin
    ;-------  all data  --------
    goodIndices = WHERE(Finite(zmeans(*,*,0)))
    ztmp  = zmeans(goodIndices)
    zplot = GRID_TPS(xtmp, ytmp, ztmp, NGRID=[Np+1,Np+1], $
                   START=[xmin,ymin], DELTA=[(xmax-xmin)/Np,(ymax-ymin)/Np])
    zplot = SMOOTH(zplot,2*Ndens+1,/EDGE_TRUNCATE)
    Nmax = 0.0
    for ix=0,Np do begin
      for iy=0,Np do begin
        xplot(ix,iy) = xmin+ix*(xmax-xmin)/Np
        yplot(ix,iy) = ymin+iy*(ymax-ymin)/Np
        ix1=ix/Ndens
        ix2=(ix+Ndens-1)/Ndens
        iy1=iy/Ndens
        iy2=(iy+Ndens-1)/Ndens
        if (zplot(ix,iy) GT 0.0) then Nmax = MAX([Nmax,zplot(ix,iy)])
        tmp=WHERE(FINITE(xmeans(ix1:ix2,iy1:iy2)),count)
        if (count EQ 0) then zplot(ix,iy)=0.0  ;!VALUES.D_NAN
      endfor
    endfor
    ;--- search for cbest-cotour that encircles 66% of the models ---
    cval = [0.0,0.01,0.03,0.1,0.2,0.3,0.45,0.6,0.75,0.9,0.99,0.999]*Nmax
    pval = cval
    psearch = 0.666667
    for i=0,N_ELEMENTS(cval)-1 do begin
      ind = WHERE(zplot GT cval(i),count)
      if (count EQ 0) then begin
        pval(i) = 0.0
      endif else begin  
        ztmp = zplot(ind)
        Nsum = 0.0
        for k=0,count-1 do begin
          Nsum = Nsum + ztmp(k)
        endfor  
        if (i EQ 0) then Ntot=Nsum
        pval(i) = Nsum/Ntot
      endelse
      print,cval(i)/Nmax,pval(i)
    endfor  
    cbest = INTERPOL(cval,pval,psearch)
    print,"==>",cbest/Nmax
    contour, zplot,xplot,yplot,xrange=[xmin,xmax],yrange=[ymin,ymax],$
           xstyle=1,ystyle=1,thick=2,charsize=1.3,position=pos,$  
           xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
           levels=cbest,c_colors=black,c_labels='',c_thick=2
  endelse

  DEVICE,/close
  SET_PLOT, 'x'
  print,'... ps-output written to '+psfile
  
END
