  ;--------------------------------------------------------
  ;--- IDL macro for creating ps-plot from xDENT output ---
  ;-------------------------------------------------------- 
 
  openr,1,'myplot.dat'
  psfile ='myplot.ps'
  tmp = '     '
  xtitel = '   ' & ytitel = '   '
  
  readf,1, tmp, col,    FORMAT='(A6,I1)'
  readf,1, tmp, NN,     FORMAT='(A6,I10)'
  readf,1, tmp, xmin,   FORMAT='(A7,E15.5)'
  readf,1, tmp, xmax,   FORMAT='(A7,E15.5)'
  readf,1, tmp, xtitel, FORMAT='(A9,A40)'
 
  val    = fltarr(2)
  val1   = '   '
  val2   = '   '
  val3   = 0.0
  val4   = 0.0
  val5   = 0.0
  xx     = fltarr(NN)
 
  if (col) then begin
    ctitel = '   '
    readf,1, tmp, cmin,   FORMAT='(A7,E15.5)'
    readf,1, tmp, cmax,   FORMAT='(A7,E15.5)'
    readf,1, tmp, clog,   FORMAT='(A7,I1)'
    readf,1, tmp, ctitel, FORMAT='(A9,A30)'
    readf,1, tmp, ncolour,FORMAT='(A10,I1)'
    cc     = fltarr(NN)
    csel   = strarr(ncolour)
    clabel = strarr(ncolour)
    colors = intarr(NN)
    for i=0,ncolour-1 do begin
      readf,1,val1,val2, FORMAT='(A6,A40)'
      csel(i)   = STRTRIM(val1,2)
      clabel(i) = STRTRIM(val2,2)
    endfor
    readf,1, tmp
    readf,1, tmp
    i=0L
    repeat begin
      readf,1,val
      xx(i)     = val(0)
      cc(i)     = val(1)
      i=i+1
    endrep until (i EQ NN)
  endif else begin
    readf,1, tmp
    readf,1, tmp    
    i=0L
    repeat begin
      readf,1,val3
      xx(i) = val3
      i=i+1
    endrep until (i EQ NN)
  endelse 
  close,1
  
  x1=17.0
  x2=13.0
  x3=1.0
  x4=1.0
  pos=[0.15,0.11,0.985,0.98]
  SET_PLOT, 'ps'
  DEVICE, filename=psfile
  DEVICE, xsize=x1,ysize=x2,xoffset=x3,yoffset=x4,/color
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (col) then begin
    if (ncolour EQ 2) then colors=[red,black]
    if (ncolour EQ 3) then colors=[red,green,black]
    if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
    if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
    if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
    if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]
  endif
  xtitel = STRTRIM(xtitel,2)
  ytitel = "number of models"
  if(col) then ctitel = STRTRIM(ctitel,2)
  ;---------------------------
  ;--- edit number of bins ---
  ;---------------------------

  bins = 40

  if (col EQ 0) then begin
    yvalues = HISTOGRAM(xx,NBINS=bins,MIN=xmin,MAX=xmax,LOCATIONS=xvalues)
    xvalues = xvalues + 0.5*((xmax-xmin)/bins)
    ymax    = 1.1*MAX(yvalues)
    plot, xvalues,yvalues,xrange=[xmin,xmax],yrange=[0,ymax],psym=10,$
          position=pos, $
          xstyle=1,ystyle=1,linestyle=0,thick=1,background=white,color=black, $
          xtitle=xtitel,ytitle=ytitel,charsize=1.1,xcharsize=1.1, $
          ycharsize=1.1, CHARTHICK=2,XTHICK=1,YTHICK=1
  endif else begin
    xbin = (xmax-xmin)/bins
    cbin = (cmax-cmin)/ncolour
    hist = HIST_2D(xx,cc,BIN1=xbin,BIN2=cbin,MAX1=xmax,MAX2=cmax,$
                   MIN1=xmin,MIN2=cmin)
    xvalues = dblarr(bins)
    for i=0,bins-1 do begin
      xvalues(i) = xmin + (i+0.5)*((xmax-xmin)/bins)
    endfor
    ymax = 0
    for i=0,ncolour-1 do begin
      tmp2 = MAX(hist(*,i))  ;/TOTAL(hist(*,i))
      if (tmp2 GT ymax) then ymax = tmp2
    endfor
    ymax = 1.1*ymax
    yvalues = hist(*,0)  ;/TOTAL(hist(*,0))
    plot, xvalues,yvalues,/nodata,xrange=[xmin,xmax],yrange=[0,ymax],$
          position=pos,$ ;ytickformat='(I6)',$
          xstyle=1,ystyle=1,xtitle=xtitel,ytitle=ytitel,$
          background=white,color=black, $
          linestyle=0,thick=3,charsize=1.1,xcharsize=1.1,ycharsize=1.1, $
          CHARTHICK=2,XTHICK=3,YTHICK=3
    xpos = 0.85    ; ~0.25 for l.h.s. legend
    ypos = 0.92
    xyouts,xpos,ypos+0.01,/normal,ctitel,ALIGNMENT=0.5,$
           CHARSIZE=1.3,color=black,CHARTHICK=3
    j=0
    xshift=0.03*ABS(xvalues(1)-xvalues(0))
    for i=0,ncolour-1 do begin
      xvalues = xvalues+xshift  
      yvalues = hist(*,i)  ;/TOTAL(hist(*,i))
      Ni = TOTAL(hist(*,i),/INTEGER)
      print,i,Ni
      if (Ni GT 0) then begin
        oplot, xvalues,yvalues,color=colors(i),PSYM=10
        cval1 = cmin+i*(cmax-cmin)/8
        cval2 = cmin+(i+1)*(cmax-cmin)/8
        if (clog) then cval1 = 10.0^cval1
        if (clog) then cval2 = 10.0^cval2
        ypos = ypos-0.03
        xyouts,xpos,ypos,/normal,ALIGNMENT=0.5,color=csel(j),CHARSIZE=1.0,$
               CHARTHICK=2, clabel(j)
        j=j+1
      endif
    endfor
  endelse

  DEVICE,/close
  SET_PLOT, 'x'
  print,'... ps-output written to '+psfile

END
