  ;--------------------------------------------------------
  ;--- IDL macro for creating ps-plot from xDENT output ---
  ;--------------------------------------------------------
 
 
  openr,1,'myplot.dat'
  psfile ='myplot.ps'
  tmp = '     '
  xtitel = '   ' & ytitel = '   '
  
  readf,1, tmp, col,    FORMAT='(A6,I1)'
  readf,1, tmp, NN,     FORMAT='(A6,I10)'
  readf,1, tmp, Ncol,   FORMAT='(A6,I10)'
  readf,1, tmp, xmin,   FORMAT='(A7,E15.5)'
  readf,1, tmp, xmax,   FORMAT='(A7,E15.5)'
  readf,1, tmp, xtitel, FORMAT='(A9,A40)'
  readf,1, tmp, ymin,   FORMAT='(A7,E15.5)'
  readf,1, tmp, ymax,   FORMAT='(A7,E15.5)'
  readf,1, tmp, ytitel, FORMAT='(A9,A40)'  

  val    = fltarr(3)
  val0   = fltarr(2)
  val1   = '   '
  val2   = '   '
  val3   = 0.0
  val4   = 0.0
  val5   = 0.0
  xx     = fltarr(NN)
  yy     = fltarr(NN)
  if (col) then begin
    ctitel = '   '
    readf,1, tmp, cmin,   FORMAT='(A7,E15.5)'
    readf,1, tmp, cmax,   FORMAT='(A7,E15.5)'
    readf,1, tmp, clog,   FORMAT='(A7,I1)'
    readf,1, tmp, ctitel, FORMAT='(A9,A30)'
    readf,1, tmp, ncolour,FORMAT='(A10,I1)'
    cc     = fltarr(NN)
    csel   = strarr(ncolour)
    clabel = strarr(ncolour)
    for i=0,ncolour-1 do begin
      readf,1,val1,val2, FORMAT='(A6,A40)'
      csel(i)   = STRTRIM(val1,2)
      clabel(i) = STRTRIM(val2,2)
    endfor
    readf,1, tmp
    readf,1, tmp
    i=0L
    repeat begin
      readf,1,val
      xx(i)     = val(0)
      yy(i)     = val(1)
      cc(i)     = val(2)
      i=i+1
    endrep until (i EQ NN)
  endif else begin
    readf,1, tmp
    readf,1, tmp    
    i=0L
    repeat begin
      readf,1,val0
      xx(i) = val0(0)
      yy(i) = val0(1)
      i=i+1
    endrep until (i EQ NN)
  endelse 
  close,1
  
  x1=17.0
  x2=13.0
  x3=1.0
  x4=1.0
  pos=[0.15,0.11,0.985,0.98]
  SET_PLOT, 'ps'
  DEVICE, filename=psfile
  DEVICE, xsize=x1,ysize=x2,xoffset=x3,yoffset=x4,/color
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (col) then begin
    if (ncolour EQ 2) then colors=[red,black]
    if (ncolour EQ 3) then colors=[red,green,black]
    if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
    if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
    if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
    if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]
  endif
  xtitel = STRTRIM(xtitel,2)
  ytitel = STRTRIM(ytitel,2)
  if(col) then ctitel = STRTRIM(ctitel,2)
  ;---------------------------
  ;--- edit number of bins ---
  ;---------------------------

  bins = 40
  
  deltax = (xmax-xmin)/bins
  xmeans = dblarr(bins)
  xmeans(*) = !VALUES.F_NAN
  ymeans = xmeans 
  xsigma = xmeans 
  ysigma = xmeans
  
  if (col EQ 0) then begin
    for i=0,bins-1 do begin
      low = xmin + i*deltax
      up  = xmin + (i+1)*deltax
      index = WHERE((xx GE low) AND (xx LT up), count)
      if (count GT 0) then begin
        if (count EQ 1) then begin
          xmeans(i) = xx(index)
          ymeans(i) = yy(index)
          xsigma(i) = 0.0
          ysigma(i) = 0.0
        endif else begin
          xbin = xx(index)
          ybin = yy(index)
          xmeans(i) = MEAN(xbin)
          xsigma(i) = STDDEV(xbin)
          ymeans(i) = MEAN(ybin)
          ysigma(i) = STDDEV(ybin)
        endelse
      endif
    endfor
    plotsym,0,0.6,/fill,color=black
    plot, xmeans,ymeans,/nodata,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,linestyle=0,thick=3,position=pos,$ 
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          charsize=1.1,xcharsize=1.1,ycharsize=1.1
    oploterror, xmeans,ymeans,xsigma,ysigma,errcolor=black,psym=8    
    ind=WHERE(FINITE(xmeans))
    oplot, xmeans(ind),ymeans(ind),color=black
  endif else begin
    dum1 = INDGEN(2)
    dum2 = INDGEN(2)
    plot, dum1,dum2,/nodata,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,linestyle=0,thick=3,position=pos,$ 
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          charsize=1.1,xcharsize=1.1,ycharsize=1.1 
    xpos = 0.85 
    ypos = 0.92
    xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=0.5,CHARSIZE=1.3,color=black, $
              CHARTHICK=3
    deltac = (cmax-cmin)/ncolour
    print,"cmin,cmax=",cmin,cmax
    ic=FLOOR((cc-cmin)/(cmax-cmin)*(ncolour-0.001))
    k=0
    for j=0,ncolour-1 do begin
      xmeans(*) = !VALUES.F_NAN
      ymeans = xmeans 
      xsigma = xmeans 
      ysigma = xmeans
      ind = WHERE(ic EQ j, count)
      print,k,count
      if (count GT 0) then begin
        x_cbin = xx(ind)
        y_cbin = yy(ind)
        for i=0,bins-1 do begin
          low = xmin + i*deltax
          up  = xmin + (i+1)*deltax
          index = WHERE((x_cbin GE low) AND (x_cbin LT up) AND (FINITE(y_cbin)), count)
          if (count GT 0) then begin
            if (count EQ 1) then begin
              xmeans(i) = x_cbin(index)
              ymeans(i) = y_cbin(index)
              xsigma(i) = 0.0
              ysigma(i) = 0.0
            endif else begin
              xbin = x_cbin(index)
              ybin = y_cbin(index)
              xmeans(i) = MEAN(xbin)
              xsigma(i) = STDDEV(xbin)
              ymeans(i) = MEAN(ybin)
              ysigma(i) = STDDEV(ybin)
            endelse
          endif
        endfor
        ind=WHERE(FINITE(xmeans),count)
        if (count GT 0) then begin
          plotsym,0,0.6,/fill,color=colors(j)
          oploterror, xmeans,ymeans,xsigma,ysigma,errcolor=colors(j),psym=8
          oplot, xmeans,ymeans,color=colors(j),psym=8     
          oplot, xmeans(ind),ymeans(ind),color=colors(j)
          ypos = ypos-0.04
          xyouts,xpos,ypos,/normal,ALIGNMENT=0.5,color=csel(k),CHARSIZE=1.0,$
                 CHARTHICK=2,clabel(k)
          k=k+1
        endif  
      endif
    endfor  
  endelse

  DEVICE,/close
  SET_PLOT, 'x'
  print,'... ps-output written to '+psfile

END
