  ;--------------------------------------------------------
  ;--- IDL macro for creating ps-plot from xDENT output ---
  ;--------------------------------------------------------

  openr,1,'myplot.dat'
  psfile ='myplot.ps'
  tmp = '     '
  xtitel = '   ' & ytitel = '   '
  
  readf,1, tmp, col,    FORMAT='(A6,I1)'
  readf,1, tmp, NN,     FORMAT='(A6,I10)'
  readf,1, tmp, xmin,   FORMAT='(A7,E15.5)'
  readf,1, tmp, xmax,   FORMAT='(A7,E15.5)'
  readf,1, tmp, ymin,   FORMAT='(A7,E15.5)'
  readf,1, tmp, ymax,   FORMAT='(A7,E15.5)'
  readf,1, tmp, xtitel, FORMAT='(A9,A40)'
  readf,1, tmp, ytitel, FORMAT='(A9,A40)'

  val    = fltarr(2)
  val1   = '   '
  val2   = '   '
  xx     = fltarr(NN)
  yy     = fltarr(NN)

  if (col) then begin
    ctitel = '   '
    readf,1, tmp, ctitel, FORMAT='(A9,A30)'
    readf,1, tmp, ncolour, FORMAT='(A10,I1)'
    readf,1, tmp
    readf,1, tmp
    csel   = strarr(ncolour)
    clabel = strarr(ncolour)
    colors = intarr(NN)
    for i=0,ncolour-1 do begin
      readf,1,val1,val2, FORMAT='(A6,A40)'
      csel(i)   = STRTRIM(val1,2)
      clabel(i) = STRTRIM(val2,2)
    endfor    
    readf,1, tmp
    readf,1, tmp
    j=0L
    repeat begin
      readf,1,val,val1
      xx(j)     = val(0)
      yy(j)     = val(1)
      colors(j) = STRTRIM(val1,2)
      j=j+1
    endrep until (j EQ NN)
  endif else begin
    readf,1, tmp
    readf,1, tmp
    j=0L
    repeat begin
      readf,1,val
      xx(j)     = val(0)
      yy(j)     = val(1)
      j=j+1
    endrep until (j EQ NN)
  endelse 
  close,1

  x1=17.0
  x2=13.0
  x3=1.0
  x4=1.0
  pos=[0.15,0.13,0.985,0.98]
  SET_PLOT, 'ps'
  DEVICE, filename=psfile
  DEVICE, xsize=x1,ysize=x2,xoffset=x3,yoffset=x4,/color
  LOADCT, 39
  xtitel = STRTRIM(xtitel,2)
  ytitel = STRTRIM(ytitel,2)
  if (col) then ctitel = STRTRIM(ctitel,2)
  if (xtitel EQ 'model_ID') then begin 
    plot, xx,yy,/nodata,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,linestyle=0,thick=3,position=pos,$ 
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          charsize=1.2,xcharsize=1.2,ycharsize=1.2, XTICKFORMAT='(I6.6)',$
          CHARTHICK=3,XTHICK=4,YTHICK=4
  endif else begin
    plot, xx,yy,/nodata,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,linestyle=0,thick=3,position=pos,$ 
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          charsize=1.2,xcharsize=1.2,ycharsize=1.2,$
          CHARTHICK=3,XTHICK=4,YTHICK=4
  endelse 
  if (NN LT 50) then begin 
    isym=1
    ssym=1.2
  endif
  if (NN GE 50 AND NN LT 50000) then begin 
    isym=1
    ssym=1.2-0.13*alog(NN/50)
  endif
  if (NN GE 50000) then begin 
    isym=3
    ssym=0.2
  endif
  if (col EQ 0) then begin
    plots, xx,yy,PSYM=isym,color=black,SYMSIZE=ssym,NOCLIP=0
  endif else begin
    xpos = 0.85    ; ~0.25 for l.h.s. legend
    ypos = 0.92
    xyouts,xpos,ypos+0.01,/normal,ctitel,ALIGNMENT=0.5,$
           CHARSIZE=1.3,color=black,CHARTHICK=4
    for i=0,ncolour-1 do begin
      if (csel(i) NE '   ') then begin
        ind = WHERE(colors EQ csel(i))
        plots, xx(ind),yy(ind),PSYM=isym,color=csel(i),$
               SYMSIZE=ssym,NOCLIP=0
  
        ypos = ypos-0.03
        xyouts,xpos,ypos,/normal,ALIGNMENT=0.5,color=csel(i),CHARSIZE=1.1,$
               CHARTHICK=3,clabel(i)
      endif
    endfor
  endelse
  DEVICE,/close
  SET_PLOT, 'x'
  print,'... ps-output written to '+psfile

END
