;--------------------------------------
; ***  plot parameter dependencies  ***
;--------------------------------------
PRO PLOT2D_MODELS, dist

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  COMMON selection, sel_models,sel_SEDs,sel_lines

  COMMON output, pswrite, datwrite

  COMMON plot, xx, yy, NN, N1, N2, sel, wid
  COMMON window, Wlist

  if (Nmod EQ 0) then begin
    print,"*** ERROR:  read a database first!"
    RETURN
  endif  
  print,"x-axis = """+xvar1+"/"+xvar2+""" log="+STRTRIM(STRING(xlog),2)  
  print,"y-axis = """+yvar1+"/"+yvar2+""" log="+STRTRIM(STRING(ylog),2)
  print,"colour = """+cname1+"/"+cname2+""" log="+STRTRIM(STRING(clog),2)
  if ((xvar1 EQ "none") OR (yvar1 EQ "none")) then begin
    print,"*** ERROR:  define x-axis and y-axis first!"
    RETURN
  endif

  openw,1,"asave.xdent"
  printf,1,xvar1
  printf,1,xvar2
  printf,1,xlog
  printf,1,yvar1
  printf,1,yvar2
  printf,1,ylog
  printf,1,cname1
  printf,1,cname2
  printf,1,clog
  printf,1,xminval
  printf,1,xmaxval
  printf,1,yminval
  printf,1,ymaxval
  printf,1,zminval
  printf,1,zmaxval
  printf,1,cminval
  printf,1,cmaxval
  printf,1,ncolour 
  printf,1,fvar1
  printf,1,fvar2
  printf,1,fvar3
  printf,1,fvar4
  printf,1,fmin1
  printf,1,fmax1
  printf,1,fmin2
  printf,1,fmax2
  printf,1,fmin3
  printf,1,fmax3
  printf,1,fmin4
  printf,1,fmax4 
  close,1

  ; --- get variables from names ---
  GET_VAR, xvar1, xxx, xtitel, xsel, dist
  GET_VAR, yvar1, yyy, ytitel, ysel, dist

  print, total(xsel)
  sel = xsel
  tmp = WHERE(ysel EQ 0, count)
  if (count GT 0) then sel(tmp) = 0 
  col = (cname1 NE 'none')
  if (ncolour EQ 1) then col = 0
  if (col) then begin
    GET_VAR, cname1, ccc, c1titel, csel, dist
    sel(WHERE(csel EQ 0, /null))=0
    ctitel=c1titel
  endif
  if (xvar2 NE 'none') then begin
    GET_VAR, xvar2, xx2, x2titel, x2sel, dist
    if ((xvar1 EQ 'alpha_SED') AND (xvar2 EQ 'beta_abs')) then begin
      xxx = xxx-xx2
      xtitel = xtitel+" - "+x2titel
    endif else begin
      xxx = xxx/xx2
      xtitel = xtitel+" / "+x2titel
    endelse  
    sel(WHERE(x2sel EQ 0, /null))=0 
    tmp=WHERE(xx2 EQ 0.0, count)
    if (xlog) then tmp=WHERE(xx2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
  endif  
  if (yvar2 NE 'none') then begin
    GET_VAR, yvar2, yy2, y2titel, y2sel, dist
    if ((yvar1 EQ 'alpha_SED') AND (yvar2 EQ 'beta_abs')) then begin
      yyy = yyy-yy2
      ytitel = ytitel+" - "+y2titel
    endif else begin
; really? I think this is a bug - IK 16.2.2015
;      xxx = yyy/yy2
      yyy = yyy/yy2
      ytitel = ytitel+" / "+y2titel
    endelse  
    sel(WHERE(y2sel EQ 0, /null))=0 
    tmp=WHERE(yy2 EQ 0.0, count)
    if (ylog) then tmp=WHERE(yy2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
  endif      
  if (col AND (cname2 NE 'none')) then begin
    GET_VAR, cname2, cc2, c2titel, c2sel, dist
    ccc = ccc/cc2
    sel(WHERE(c2sel EQ 0, /null))=0 
    tmp=WHERE(cc2 EQ 0.0, count)
    if (clog) then tmp=WHERE(cc2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
    ctitel = ctitel+" / "+c2titel
  endif      
  print, total(sel)
  if (xlog) then begin            ; de-select negative points if log
    tmp = WHERE(xxx LE 0.0, count)
    print, 'negative x values', count
    if (count GT 0) then sel(tmp)=0 
  endif  
  if (ylog) then begin
    tmp = WHERE(yyy LE 0.0, count)
    print, 'negative y values', count
    if (count GT 0) then sel(tmp)=0 
  endif  
  if (col AND clog) then begin
    tmp = WHERE(ccc LE 0.0, count)
    print, 'negative color coding values', count
    if (count GT 0) then sel(tmp)=0 
  endif 

  print, total(sel)

  ; --- filter model selection according to specified values ---

  if (fvar1 NE 'none') then begin
   print, 'fvar1' 
   GET_VAR, fvar1, filter1, dum1, dum2, dist
    if (fmin1 NE 'auto') then begin
      reads,fmin1,val
      ind = WHERE(filter1 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax1 NE 'auto') then begin
      reads,fmax1,val
      ind = WHERE(filter1 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar2 NE 'none') then begin
    print, 'fvar2' 
    GET_VAR, fvar2, filter2, dum1, dum2, dist
    if (fmin2 NE 'auto') then begin
      reads,fmin2,val
      ind = WHERE(filter2 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax2 NE 'auto') then begin
      reads,fmax2,val
      ind = WHERE(filter2 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar3 NE 'none') then begin
    print, 'fvar3' 
    GET_VAR, fvar3, filter3, dum1, dum2, dist
    if (fmin3 NE 'auto') then begin
      reads,fmin3,val
      ind = WHERE(filter3 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax3 NE 'auto') then begin
      reads,fmax3,val
      ind = WHERE(filter3 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar4 NE 'none') then begin
    print, 'fvar4' 
    GET_VAR, fvar4, filter4, dum1, dum2, dist
    if (fmin4 NE 'auto') then begin
      reads,fmin4,val
      ind = WHERE(filter4 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax4 NE 'auto') then begin
      reads,fmax4,val
      ind = WHERE(filter4 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (max(sel) LT 1) then begin
    print,"*** no points to be plotted according to this selection"
    return
  endif
  xx = xxx(WHERE(sel EQ 1, count))  
  print, 'xxx', count
  if (count gt 0) then N1plot=N_ELEMENTS(xx)
  yy = yyy(WHERE(sel EQ 1, count))
  if (count gt 0) then N2plot=N_ELEMENTS(yy)
  if (col) then cc = ccc(WHERE(sel EQ 1, count))  
  if (count gt 0) then N3plot=N_ELEMENTS(cc)

  if (xlog) then begin
    xtitel = "log!L !N"+xtitel  
    xx = ALOG10(xx)
  endif  
  if (ylog) then begin
    ytitel = "log!L !N"+ytitel  
    yy = ALOG10(yy)
  endif  
  if (col AND clog) then begin
    ctitel = "log!L !N"+ctitel  
    cc = ALOG10(cc)
  endif  

  NN=N_ELEMENTS(xx)
  dimensions = GET_SCREEN_SIZE(RESOLUTION=resolution)
  xstart=min([528,dimensions(0)-650-8])
  base = WIDGET_BASE(TITLE=STRTRIM(STRING(NN),2)+" "+gridNAME+" models",$
                     XOFFSET=xstart,YOFFSET=0, KILL_NOTIFY="PLOT_CLOSED")
  drawID = WIDGET_DRAW(base,RETAIN=2,XSIZE=650,YSIZE=500,/BUTTON_EVENTS)
  WIDGET_CONTROL, drawID, /Realize
  WIDGET_CONTROL, drawID, Get_Value=wid
  WSET, wid
  DEVICE,DECOMPOSED=0
  DEVICE,/CURSOR_ORIGINAL
  XMANAGER, 'plot2d',drawID, /NO_BLOCK
  for i=0,99 do begin
    if (Wlist(i) EQ 0) then begin
      Wlist(i) = base
      break
    endif
  endfor
  ;print, Wlist
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (ncolour EQ 2) then colors=[red,black]
  if (ncolour EQ 3) then colors=[red,green,black]
  if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
  if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
  if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
  if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]
  pos=[0.15,0.10,0.98,0.97]
  x1=min(xx)
  x2=max(xx)
  y1=min(yy)
  y2=max(yy)
  xmin = x1-0.05*(x2-x1)
  xmax = x2+0.05*(x2-x1)
  ymin = y1-0.05*(y2-y1)
  ymax = y2+0.05*(y2-y1)
  if (xminval NE "auto") then begin
    reads,xminval,xmin
    if (xlog) then xmin=ALOG10(xmin)
  endif
  if (xmaxval NE "auto") then begin
    reads,xmaxval,xmax
    if (xlog) then xmax=ALOG10(xmax)
  endif
  if (yminval NE "auto") then begin
    reads,yminval,ymin
    if (ylog) then ymin=ALOG10(ymin)
  endif
  if (ymaxval NE "auto") then begin
    reads,ymaxval,ymax
    if (ylog) then ymax=ALOG10(ymax)
  endif
  if (xmax LE xmin) then begin
    xmin=xmin-0.5 
    xmax=xmin+1.0
  endif
  if (ymax LE ymin) then begin
    ymin=ymin-0.5 
    ymax=ymin+1.0
  endif
  print,"now plotting "+STRING(NN)+" data points ..."
  print,"xmin,xmax=",x1,x2
  print,"ymin,ymax=",y1,y2
  if (xvar1 EQ 'model_ID') then begin 
    plot, xx,yy,/nodata,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,linestyle=0,thick=2,position=pos,$ 
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          charsize=1.2,xcharsize=1.3,ycharsize=1.3, XTICKFORMAT='(I6.6)'
  endif else begin
    plot, xx,yy,/nodata,xrange=[xmin,xmax],yrange=[ymin,ymax],$
          xstyle=1,ystyle=1,linestyle=0,thick=2,position=pos,$ 
          xtitle=xtitel,ytitle=ytitel,background=white,color=black,$
          charsize=1.2,xcharsize=1.3,ycharsize=1.3
  endelse  
  if (NN LT 50) then begin 
    isym=1
    ssym=1.2
  endif
  if (NN GE 50 AND NN LT 50000) then begin 
    isym=1
    ssym=1.2-0.13*alog(NN/50)
  endif
  if (NN GE 50000) then begin 
    isym=3
    ssym=0.2
  endif
  if (col EQ 0) then begin
    plots, xx,yy,PSYM=isym,color=black,SYMSIZE=ssym,NOCLIP=0
  endif else begin
    xpos = 0.96  
    ypos = 0.92
    xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=1.0,CHARSIZE=1.5,color=black
    cmin=min(cc)
    cmax=max(cc)
    if (cminval NE "auto") then begin
      reads,cminval,cmin
      if (clog) then cmin=ALOG10(cmin)
    endif
    if (cmaxval NE "auto") then begin
      reads,cmaxval,cmax
      if (clog) then cmax=ALOG10(cmax)
    endif
    csel  =strarr(ncolour) ; colours and labels
    clabel=strarr(ncolour) ;     for output 
    j=0              ; into 'nice_plots.dat
    if (cmax EQ cmin) then cmin=cmax-0.01     ; all in black
    print,"cmin,cmax=",cmin,cmax
    ic=FLOOR((cc-cmin)/(cmax-cmin)*(ncolour-0.001))
    for i=0,ncolour-1 do begin
      ind = WHERE(ic EQ i, count)
      print,i,count
      if (count GE 1) then begin
        plots, xx(ind),yy(ind),PSYM=isym,color=colors(i),$
               SYMSIZE=ssym,NOCLIP=0
        ypos = ypos-0.03
        cval1 = cmin+i*(cmax-cmin)/ncolour
        cval2 = cmin+(i+1)*(cmax-cmin)/ncolour
        if (clog) then cval1 = 10.0^cval1
        if (clog) then cval2 = 10.0^cval2
        xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=colors(i),CHARSIZE=1.2,$
               STRING(format='(E7.1,"!L !N...!L !N",E7.1)',cval1,cval2)
        clabel(j) = STRING(format='(E7.1,"!L !N...!L !N",E7.1)',cval1,cval2)  
        csel(j)   = STRING(format='(I3)',colors(i))
        j=j+1     
      endif
    endfor
  endelse
  

  ;------------------------------------------
  ;--- calculate correlation coefficients ---
  ;------------------------------------------
  ;if (col) then begin
  ;  tmp = WHERE(FINITE(xx) AND FINITE(yy) AND FINITE(cc))
  ;  Pearson  = CORRELATE( xx(tmp),yy(tmp) ) 
  ;  Spearman = R_CORRELATE( xx(tmp),yy(tmp) ) 
  ;  Kendall  = R_CORRELATE( xx(tmp),yy(tmp),/KENDALL ) 
  ;  print,"Pearson's  X-Y correlation =",Pearson 
  ;  print,"Spearman's X-Y correlation =",Spearman 
  ;  print,"Kendall's  X-Y correlation =",Kendall
  ;  print
  ;  Pearson  = CORRELATE( cc(tmp),yy(tmp) ) 
  ;  Spearman = R_CORRELATE( cc(tmp),yy(tmp) ) 
  ;  Kendall  = R_CORRELATE( cc(tmp),yy(tmp),/KENDALL ) 
  ;  print,"Pearson's  C-Y correlation =",Pearson 
  ;  print,"Spearman's C-Y correlation =",Spearman 
  ;  print,"Kendall's  C-Y correlation =",Kendall
  ;  print
  ;endif  

  ;---------------------------------------------------------
  ;--- write data to file to allow personal 'nice' plots ---
  ;---------------------------------------------------------
  if (datwrite) then begin
    filename = DIALOG_PICKFILE(/READ,FILE='myplot.dat',FILTER='*.dat')   
    if (STRPOS(filename,'.dat') EQ -1) then return
    openw,1,filename
    printf,1,"col = ",   col,    FORMAT='(A6,I1)'
    printf,1,"NN =  ",   NN,     FORMAT='(A6,I10)'
    printf,1,"xmin = ",  xmin,   FORMAT='(A7,E15.5)'
    printf,1,"xmax = ",  xmax,   FORMAT='(A7,E15.5)'
    printf,1,"ymin = ",  ymin,   FORMAT='(A7,E15.5)'
    printf,1,"ymax = ",  ymax,   FORMAT='(A7,E15.5)'
    printf,1,"xtitel = ",xtitel, FORMAT='(A9,A40)'
    printf,1,"ytitel = ",ytitel, FORMAT='(A9,A40)'
    if (col) then begin
      printf,1,"ctitel = ",ctitel, FORMAT='(A9,A30)'
      printf,1,"ncolour =",ncolour, FORMAT='(A10,I1)'
      printf,1,"         "
      printf,1,"colour","colour label",FORMAT='(A6,A30)'
      for i=0,ncolour-1 do begin
        printf,1,csel(i),clabel(i),  FORMAT='(A6,A40)'
      endfor
      printf,1,"       "
      printf,1,"x values","y values", "colour",FORMAT='(3A15)'
      if (cmax EQ cmin) then cmin=cmax-0.01 ; all in black
      j=0L
      repeat begin
        ic=FLOOR((cc(j)-cmin)/(cmax-cmin)*(ncolour-0.001))
        for i=0,ncolour-1 do begin
          if (i EQ ic) then begin
            printf,1,xx(j),yy(j),colors(i),FORMAT='(2E15.5,I15)'
          endif
        endfor
        j=j+1
      endrep until (j EQ NN)
    endif else begin
      printf,1,"       "
      printf,1,"x values","y values",FORMAT='(2A15)'
      j=0L
      repeat begin
        printf,1,xx(j),yy(j),FORMAT='(2E15.5)'
        j=j+1
      endrep until (j EQ NN)
    endelse 
    close,1  
    print,"... output written to "+STRTRIM(filename)+"."
     
    if (filename NE 'nice_plot.dat') then begin
      core=STRMID(filename,0,STRLEN(filename)-4) 
      ipos=STRPOS(core,'/',/REVERSE_SEARCH)
      if (ipos GT 0) then core=STRMID(core,ipos+1)
      file1='nice_plot.pro'
      file2=core+'.pro'
      openr,1,file1
      openw,2,file2
      line=' '
      for i=1,9999 do begin
        readf,1,line
        if (STRPOS(line,'myplot.dat') NE -1) then begin 
          line='  openr,1,'''+filename+'''' 
        endif
        if (STRPOS(line,'myplot.ps') NE -1) then begin 
          line='  psfile ='''+core+'.ps'''
        endif    
        printf,2,line
        if (STRTRIM(line,2) EQ 'END') then break
      endfor
      close,1
      close,2
      print,"... created "+file2+"."
    endif

    print,"----------------------------------------------------------------"
    print,"***  Next, type .r "+core+" to produce a nice ps-plot.       ***"
    print,"***  Feel free to modify "+file2+" to optimize your plot. ***"
    print,"----------------------------------------------------------------"
    print

  endif

  END
