;-------------------------------------------------
; ***  plot histograms using model parameters  ***
;-------------------------------------------------
PRO PLOT_HISTOGRAM, dist

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME
 
  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  COMMON selection, sel_models,sel_SEDs,sel_lines
  COMMON output, pswrite, datwrite
  COMMON window, Wlist

  if (Nmod EQ 0) then begin
    print,"*** ERROR:  read a database first!"
    RETURN
  endif 
  print,"x-axis = """+xvar1+"/"+xvar2+""" log="+STRTRIM(STRING(xlog),2)  
  print,"colour = """+cname1+"/"+cname2+""" log="+STRTRIM(STRING(clog),2)
  if (xvar1 EQ "none") then begin
    print,"*** ERROR:  define x-axis first!"
    RETURN
  endif
  
  openw,1,"asave.xdent"
  printf,1,xvar1
  printf,1,xvar2
  printf,1,xlog
  printf,1,yvar1
  printf,1,yvar2
  printf,1,ylog
  printf,1,cname1
  printf,1,cname2
  printf,1,clog
  printf,1,xminval
  printf,1,xmaxval
  printf,1,yminval
  printf,1,ymaxval
  printf,1,zminval
  printf,1,zmaxval
  printf,1,cminval
  printf,1,cmaxval
  printf,1,ncolour
  printf,1,fvar1
  printf,1,fvar2
  printf,1,fvar3
  printf,1,fvar4
  printf,1,fmin1
  printf,1,fmax1
  printf,1,fmin2
  printf,1,fmax2
  printf,1,fmin3
  printf,1,fmax3
  printf,1,fmin4
  printf,1,fmax4 
  close,1
  
  ; --- get variables from names ---
  GET_VAR, xvar1, xxx, xtitel, xsel, dist
  sel = xsel
  col = (cname1 NE 'none')
  if (ncolour EQ 1) then col = 0 
  if (col) then begin
    GET_VAR, cname1, ccc, c1titel, csel, dist
    sel(WHERE(csel EQ 0))=0
    ctitel=c1titel
  endif
  if (xvar2 NE 'none') then begin
    GET_VAR, xvar2, xx2, x2titel, x2sel, dist
    if ((xvar1 EQ 'alpha_SED') AND (xvar2 EQ 'beta_abs')) then begin
      xxx = xxx-xx2
      xtitel = xtitel+" - "+x2titel
    endif else begin
      xxx = xxx/xx2
      xtitel = xtitel+" / "+x2titel
    endelse  
    sel(WHERE(x2sel EQ 0))=0 
    tmp=WHERE(xx2 EQ 0.0, count)
    if (xlog) then tmp=WHERE(xx2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
  endif  
  if (col AND (cname2 NE 'none')) then begin
    GET_VAR, cname2, cc2, c2titel, c2sel, dist
    ccc = ccc/cc2
    sel(WHERE(c2sel EQ 0))=0 
    tmp=WHERE(cc2 EQ 0.0, count)
    if (clog) then tmp=WHERE(cc2 LE 0.0, count)
    if (count GT 0) then sel(tmp)=0
    ctitel = ctitel+" / "+c2titel
  endif
  if (xlog) then begin            ; de-select negative points if log
    tmp = WHERE(xxx LE 0.0, count)
    if (count GT 0) then sel(tmp)=0 
  endif 
  if (col AND clog) then begin
    tmp = WHERE(ccc LE 0.0, count)
    if (count GT 0) then sel(tmp)=0 
  endif 
  
  ; --- filter model selection according to specified values ---

  if (fvar1 NE 'none') then begin
    GET_VAR, fvar1, filter1, dum1, dum2, dist
    if (fmin1 NE 'auto') then begin
      reads,fmin1,val
      ind = WHERE(filter1 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax1 NE 'auto') then begin
      reads,fmax1,val
      ind = WHERE(filter1 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar2 NE 'none') then begin
    GET_VAR, fvar2, filter2, dum1, dum2, dist
    if (fmin2 NE 'auto') then begin
      reads,fmin2,val
      ind = WHERE(filter2 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax2 NE 'auto') then begin
      reads,fmax2,val
      ind = WHERE(filter2 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar3 NE 'none') then begin
    GET_VAR, fvar3, filter3, dum1, dum2, dist
    if (fmin3 NE 'auto') then begin
      reads,fmin3,val
      ind = WHERE(filter3 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax3 NE 'auto') then begin
      reads,fmax3,val
      ind = WHERE(filter3 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (fvar4 NE 'none') then begin
    GET_VAR, fvar4, filter4, dum1, dum2, dist
    if (fmin4 NE 'auto') then begin
      reads,fmin4,val
      ind = WHERE(filter4 LT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
    if (fmax4 NE 'auto') then begin
      reads,fmax4,val
      ind = WHERE(filter4 GT val,count)
      if (count GT 0) then sel(ind) = 0
    endif
  endif
  if (max(sel) LT 1) then begin
    print,"*** no points to be plotted according to this selection"
    return
  endif
  xx = xxx(WHERE(sel EQ 1))  
  if (col) then cc = ccc(WHERE(sel EQ 1))  
  
  if (xlog) then begin
    xtitel = "log!L !N"+xtitel  
    xx = ALOG10(xx)
  endif  
  if (col AND clog) then begin
    ctitel = "log!L !N"+ctitel  
    cc = ALOG10(cc)
  endif 
  ytitel = "number of models"
  NN=N_ELEMENTS(xx)
  
  dimensions = GET_SCREEN_SIZE(RESOLUTION=resolution)
  xstart=min([528,dimensions(0)-650-8])
  base = WIDGET_BASE(TITLE=STRTRIM(STRING(NN),2)+" "+gridNAME+" models",$
                     XOFFSET=xstart,YOFFSET=0, KILL_NOTIFY="PLOT_CLOSED")
  drawID = WIDGET_DRAW(base,RETAIN=2,XSIZE=650,YSIZE=500)
  WIDGET_CONTROL, drawID, /Realize
  WIDGET_CONTROL, drawID, Get_Value=wid
  WSET, wid
  DEVICE,DECOMPOSED=0
  for i=0,99 do begin
    if (Wlist(i) EQ 0) then begin
      Wlist(i) = base
      break
    endif
  endfor
  LOADCT, 39
  white   = 255
  red     = 250
  orange  = 210
  yellow  = 195
  green   = 160
  cyan    = 100
  blue    = 70
  magenta = 30
  black   = 0
  colors=[red,orange,yellow,green,cyan,blue,magenta,black]
  if (ncolour EQ 2) then colors=[red,black]
  if (ncolour EQ 3) then colors=[red,green,black]
  if (ncolour EQ 4) then colors=[red,yellow,cyan,black]
  if (ncolour EQ 5) then colors=[red,yellow,green,blue,black]
  if (ncolour EQ 6) then colors=[red,yellow,green,cyan,blue,black]
  if (ncolour EQ 7) then colors=[red,orange,yellow,green,cyan,blue,black]
  pos=[0.15,0.10,0.98,0.97]
  x1=min(xx)
  x2=max(xx)
  xmin = x1-0.05*(x2-x1)
  xmax = x2+0.05*(x2-x1)
  if (xminval NE "auto") then begin
    reads,xminval,xmin
    if (xlog) then xmin=ALOG10(xmin)
  endif
  if (xmaxval NE "auto") then begin
    reads,xmaxval,xmax
    if (xlog) then xmax=ALOG10(xmax)
  endif
  if (xmax LE xmin) then begin
    xmin=xmin-0.5 
    xmax=xmin+1.0
  endif

  bins = 20

  if (col EQ 0) then begin
    
    yvalues = HISTOGRAM(xx,NBINS=bins,MIN=xmin,MAX=xmax,LOCATIONS=xvalues)
    xvalues = xvalues + 0.5*((xmax-xmin)/bins)
    ymax    = 1.1*MAX(yvalues)
    Nhist   = TOTAL(yvalues)
    if (Nhist NE NN) then begin
      print, "**WARNING: #models in histogram bins doesn't equal total"
    endif
    print, "now plotting histogram for ", Nhist, " models ...",$
           FORMAT='(A27,I7,A11)'
    plot, xvalues,yvalues,xrange=[xmin,xmax],yrange=[0,ymax],psym=10,$
          position=pos, $
          xstyle=1,ystyle=1,linestyle=0,background=white,color=black, $
          xtitle=xtitel,ytitle=ytitel,charsize=1.2,xcharsize=1.3,ycharsize=1.3
  endif else begin
    cmin=min(cc)
    cmax=max(cc)
    if (cmax EQ cmin) then cmin=cmax-0.01 ; all in black
    cmin = cmin-0.01*(cmax-cmin)
    cmax = cmax+0.01*(cmax-cmin)
    if (cminval NE "auto") then begin
      reads,cminval,cmin
      if (clog) then cmin=ALOG10(cmin)
    endif
    if (cmaxval NE "auto") then begin
      reads,cmaxval,cmax
      if (clog) then cmax=ALOG10(cmax)
    endif
    csel  =strarr(ncolour) ; colours and labels
    clabel=strarr(ncolour) ;     for output 
    j=0                    ; into 'nice_hist.dat
    xbin = (xmax-xmin)/bins
    cbin = (cmax-cmin)/ncolour
    hist = HIST_2D(xx,cc,BIN1=xbin,BIN2=cbin,MAX1=xmax,MAX2=cmax,$
                   MIN1=xmin,MIN2=cmin)
    xvalues = dblarr(bins)
    Nhist = TOTAL(hist,/INTEGER)
    if (Nhist NE NN) then begin
      print, "**WARNING: #models in histogram bins doesn't equal total"
    endif
    print, "now plotting histogram for ", Nhist, " models ...",$
           FORMAT='(A27,I7,A11)'
    for i=0,bins-1 do begin
      xvalues(i) = xmin + (i+0.5)*((xmax-xmin)/bins)
    endfor
    ymax = 0
    for i=0,ncolour-1 do begin
      tmp = MAX(hist(*,i)) ;/TOTAL(hist(*,i))
      if (tmp GT ymax) then ymax = tmp
    endfor
    ymax = 1.1*ymax
    yvalues = hist(*,0) ;/TOTAL(hist(*,0))
    plot, xvalues,yvalues,/nodata,xrange=[xmin,xmax],yrange=[0,ymax],$
          position=pos,$ ;ytickformat='(I6)',$
          xstyle=1,ystyle=1,xtitle=xtitel,ytitle=ytitel,$
          background=white,color=black, $
          linestyle=0,thick=2,charsize=1.2,xcharsize=1.3,ycharsize=1.3
    xpos = 0.96
    ypos = 0.92
    xyouts,xpos,ypos,/normal,ctitel,ALIGNMENT=1.0,CHARSIZE=1.5,color=black
    mean  = dblarr(ncolour)
    sigma = dblarr(ncolour)
    if (clog) then begin
      ctitshort = "log "+STRMID(ctitel,8)
    endif else begin
      ctitshort = ctitel 
    endelse
    if (xlog) then begin
      xtitshort = "log "+STRMID(xtitel,8)
    endif else begin
      xtitshort = xtitel
    endelse
    xshift=0.03*ABS(xvalues(1)-xvalues(0))
    for i=0,ncolour-1 do begin
      xvalues = xvalues+xshift
      yvalues = hist(*,i) ;/TOTAL(hist(*,i))
      Ni = TOTAL(hist(*,i),/INTEGER)
      print,i,Ni
      if (Ni GT 0) then begin
        oplot, xvalues,yvalues,color=colors(i),PSYM=10,NOCLIP=0
        ypos = ypos-0.03
        cval1 = cmin+i*(cmax-cmin)/ncolour
        cval2 = cmin+(i+1)*(cmax-cmin)/ncolour
        if (clog) then cval1 = 10.0^cval1
        if (clog) then cval2 = 10.0^cval2
        xyouts,xpos,ypos,/normal,ALIGNMENT=1.0,color=colors(i),CHARSIZE=1.2,$
               STRING(format='(E7.1,"!L !N...!L !N",E7.1)',cval1,cval2)
        clabel(j) = STRING(format='(E7.1,"!L !N...!L !N",E7.1)',cval1,cval2)  
        csel(j)   = STRING(format='(I3)',colors(i))
        j=j+1     
      endif    
    endfor 
  endelse
  
  ;---------------------------------------------------------
  ;--- write data to file to allow personal 'nice' plots ---
  ;---------------------------------------------------------
  
  if (datwrite) then begin
    filename = DIALOG_PICKFILE(/WRITE,FILE='myplot.dat',FILTER='*.dat')   
    if (STRPOS(filename,'.dat') EQ -1) then return
    openw,1,filename
    printf,1,"col = ",   col,    FORMAT='(A6,I1)'
    printf,1,"NN =  ",   NN,     FORMAT='(A6,I10)'
    printf,1,"xmin = ",  xmin,   FORMAT='(A7,E15.5)'
    printf,1,"xmax = ",  xmax,   FORMAT='(A7,E15.5)'
    printf,1,"xtitel = ",xtitel, FORMAT='(A9,A40)'

    if (col) then begin
      printf,1,"cmin = ",  cmin,   FORMAT='(A7,E15.5)'
      printf,1,"cmax = ",  cmax,   FORMAT='(A7,E15.5)'
      printf,1,"clog = ",  clog,   FORMAT='(A7,I1)'
      printf,1,"ctitel = ",ctitel, FORMAT='(A9,A30)'
      printf,1,"ncolour = ",ncolour, FORMAT='(A10,I1)'
      for i=0,ncolour-1 do begin
        printf,1,csel(i),clabel(i),  FORMAT='(A6,A40)'
      endfor
      printf,1,"         "
      printf,1,"x values","c values",FORMAT='(2A15)'
      i=0L
      repeat begin
        printf,1,xx(i),cc(i),FORMAT='(2E15.5)'
        i=i+1
      endrep until (i EQ NN)
    endif else begin
      printf,1,"       "
      printf,1,"x values",FORMAT='(A15)'
      i=0L
      repeat begin
        printf,1,xx(i),FORMAT='(E15.5)'
        i=i+1
      endrep until (i EQ NN)
    endelse 
    close,1  
    print,"... output written to "+STRTRIM(filename)+"."
     
    if (filename NE 'nice_hist.dat') then begin
      core=STRMID(filename,0,STRLEN(filename)-4) 
      ipos=STRPOS(core,'/',/REVERSE_SEARCH)
      if (ipos GT 0) then core=STRMID(core,ipos+1)
      file1='nice_hist.pro'
      file2=core+'.pro'
      openr,1,file1
      openw,2,file2
      line=' '
      for i=1,9999 do begin
        readf,1,line
        if (STRPOS(line,'myplot.dat') NE -1) then begin 
          line='  openr,1,'''+filename+'''' 
        endif
        if (STRPOS(line,'myplot.ps') NE -1) then begin 
          line='  psfile ='''+core+'.ps'''
        endif    
        printf,2,line

        if (STRTRIM(line,2) EQ 'END') then break
      endfor
      close,1
      close,2
      print,"... created "+file2+"."
    endif

    print,"----------------------------------------------------------------"
    print,"***  Next, type .r "+core+" to produce a nice ps-plot.       ***"
    print,"***  Feel free to modify "+file2+" to optimize your plot. ***"
    print,"----------------------------------------------------------------"
    print
   


  endif
END
