
;------------------------------------------
; ***  plot SED and observational data  ***
;------------------------------------------
PRO PLOT_SED, dist,incl1,Nlam,lamcont,Fcont,Nobs,lamobs,Fnuobs

  COMMON fits, ID_best,gas_best,incl1_best,incl2_best,chi_best
  COMMON SEDplot, Nplotted,Fmin,Fmax 
  COMMON window, Wlist

  if (Nplotted GT 9) then return
  if (ID_best(Nplotted) LT 0) then return

  print,"plotting SED ...",Nplotted,ID_best(Nplotted)+1

  id   = ID_best(Nplotted)
  igas = gas_best(Nplotted)
  ii   = incl1_best(Nplotted)
  chi  = chi_best(Nplotted)
  Nplotted = Nplotted+1
  print, ii, Nplotted, SIZE(Fcont,/DIMENSIONS)
  Fmodel = fltarr(Nlam)
  Fmodel(*) = Fcont(id,ii,*)*(140.0/dist)^2
  incl   = incl1(ii)
  cl     = 2.997924580D+10      ; speed of light
  Jansky = 1.D-23               ; 1 Jy in [erg/cm^2/s/Hz]
  lam1   = lamcont*1.D-4        ; lamdba [cm]
  nu     = cl/lam1              ; nu [Hz]
  nuFnu1 = nu*Fmodel*Jansky     ; nuFnu [erg/cm^2/s]
  ;print,lamcont
  ;print,nuFnu1
  if (Nplotted EQ 1) then begin
    Fmin=min(alog10(nuFnu1(5:Nlam-1)))-0.5
    Fmax=max(alog10(nuFnu1(5:Nlam-1)))+0.5
  endif  
  xmin=[min(lamcont)*0.8]
  xmax=[max(lamcont)*1.2]
  ;Fmin=-15.5
  ;Fmax=-8.5
  ;WINDOW, Nplotted, Title="model #"+STRTRIM(STRING(id+1),2)+$
  ;           "  incl="+STRTRIM(STRING(format='(F8.1)',incl1(ii)),2)+$
  ;           "  chi="+STRTRIM(STRING(format='(F8.3)',chi),2),$
  ;        XPOS=505+20*Nplotted,YPOS=640-20*Nplotted,$ 
  ;        RETAIN=2, XSIZE=540,YSIZE=400   
  base = WIDGET_BASE(TITLE="model #"+STRTRIM(STRING(id+1),2)+$
              "  incl="+STRTRIM(STRING(format='(F8.1)',incl1(ii)),2)+$
              "  chi="+STRTRIM(STRING(format='(F8.3)',chi),2),$
              XOFFSET=500+20*Nplotted,YOFFSET=20*Nplotted,$
              KILL_NOTIFY="PLOT_CLOSED")
  drawID = WIDGET_DRAW(base,RETAIN=2,XSIZE=540,YSIZE=400)
  WIDGET_CONTROL, drawID, /Realize
  WIDGET_CONTROL, drawID, Get_Value=wid
  WSET, wid
   for i=0,99 do begin
    if (Wlist(i) EQ 0) then begin
      Wlist(i) = base
      break
    endif
  endfor
  pos=[0.15,0.15,0.9,0.9]
  plot, lamcont,alog10(nuFnu1),/xlog,xrange=[xmin,xmax],yrange=[Fmin,Fmax],$
        xstyle=1,ystyle=1,linestyle=0,thick=2,position=pos,$ 
        xtitle="lambda [mic]",$
        ytitle="log nuFnu [erg/cm!U2!N/s]"
  if (Nobs GT 0) then begin
    lam2   = lamobs*1.E-4
    nu     = cl/lam2
    nuFnu2 = nu*Fnuobs*Jansky  
    oplot,lamobs,alog10(nuFnu2),PSYM=5,SYMSIZE=1.0
  endif
  INFO_MODEL,id,igas,dist
END ; PLOT_SED
