;--------------------------------------------------------------------
PRO READDATA
;--------------------------------------------------------------------

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  COMMON selection, sel_models,sel_SEDs,sel_lines

  header=" "
  Ngas    = 5    ; dust/gas values
  Nincl1  = 12   ; SED inclinations
  Nincl2  = 5    ; Line inclinations
  if (basenr EQ 1) then begin
    gridNAME = "beta GRID"
    print,"reading betaGRID" 
    folder="../betaGRID"
    Ngas   = 1
    Nmod   = 1000L
    Nincl1 = 5
    totread1 = Nmod    
    totread2 = Nmod/Ngas*Nincl1 
    totread3 = Nmod*Nincl2    
  endif
;  if (basenr EQ 2) then begin
;    gridNAME = "testgrid 2"
;    print,"reading testgrid 2" 
;    folder="../TESTGRID2"
;    Nmod = 1728L
;    totread1 = Nmod*2    
;    totread2 = Nmod/2*Nincl1       ; /2 because models were calculated twice
;    totread3 = Nmod/2*2*Nincl2    
;  endif
; change 3 to 2
  if (basenr EQ 2) then begin
    gridNAME = "DENT"
    print,"reading DENT grid " 
    folder="../DENTgrid"
    Nmod     = 64800L
    Nincl1   = 5
    totread1 = 322030L
    totread2 = totread1/Ngas*Nincl1
    totread3 = totread1*Nincl2
  endif
  modelID = lonarr(Nmod,Ngas)
  age     = fltarr(Nmod,Ngas)
  Mdust   = fltarr(Nmod,Ngas)
  Mdust(*,*) = !VALUES.F_NAN

  ;--------- unformated MasterFile present? ---------
  unform=0
  openr, 2, folder+"/Master.dat",ERROR=ERR
  if (ERR EQ 0) then begin
    print,"Reading unformatted data from "+folder+"/Master.dat ..."
    close,2
    unform=1
  endif else begin
    print,"Reading formatted data from "+folder+" ..."
    print,"------------------------------------------------"
    print,"***  This will take a while ...         :-(  ***"
    print,"***  I promise to be faster next time!  :-)  ***"
    print,"------------------------------------------------"
  endelse  

  ;--------- read MasterSpecies ---------  
  openr, 1, folder+"/MasterSpecies.dat"
  readf,1,header
  readf,1,header
  readf,1,header
  readf,1,header
  readf,1,header
  pname=STRARR(300)
  Nname=0
  while (STRLEN(header) GT 0) do begin
    NEXTWORD,header,word
    pname(Nname)=word
    if (strpos(word,"Mdisk") GE 0) then begin
      pname(Nname)="Mgas[Msun]" 
    endif   
    if (strpos(word,"<Td>") GE 0) then begin
      sp = strtrim(pname(Nname-2),2)
      pname(Nname-2) = "M_"+sp
      pname(Nname-1) = "<Tg_"+sp+">"
      pname(Nname-0) = "<Td_"+sp+">"
    endif  
    Nname=Nname+1
  endwhile
  ParaName       = pname(1:Nname-1)
  ParaVal        = fltarr(Nname-1,Nmod,Ngas)
  ParaVal(*,*,*) = !VALUES.F_NAN
  if (unform EQ 0) then begin
    print,"reading "+folder+"/MasterSpecies.dat ..."
    val = fltarr(Nname-1)
    if (basenr EQ 1) then begin
      form='(I5.5,1x,I1,F9.1,10(E12.4),4(E12.4),9(E12.4,F9.2,F9.2))'
    endif  
;    if (basenr EQ 2) then begin
;      form='(1x,I5.5,I1,F9.1,10(E12.4),F9.5,2(E12.4),5(E12.4,F9.2,F9.2))'
;    endif
; change 3 to 2
    if (basenr EQ 2) then begin
      form='(I5.5,1x,I1,F9.1,10(E12.4),F9.5,2(E12.4),5(E12.4,F9.2,F9.2))'
    endif
    time0=systime(1)
    perc0=0.0
    idat1=0L
    id=0L
    igas=0
    iMgas    = WHERE(strpos(ParaName,"Mgas") GE 0)
    idustgas = WHERE(strpos(ParaName,"dust/gas") GE 0)
    while (~EOF(1)) do begin
      readf,1,format=form,id,igas,val
      id=id-1
      igas=igas-1
      idat1=idat1+1
      ParaVal(*,id,igas) = val(*)
      modelID(id,igas) = (id+1)*10+(igas+1)
      Mdust(id,igas)   = ParaVal(iMgas,id,igas)*ParaVal(idustgas,id,igas)
      perc1 = idat1*100.0/totread1
      if (perc1 GT perc0+10.0) then begin
        perc0=perc1
        time1=systime(1)
        print,format='(F5.1,"% time=",F5.1,"sec")',perc1,time1-time0
      endif  
    endwhile
    perc1 = idat1*100.0/totread1
    time1 = systime(1)
    print,format='(F5.1,"% time=",F5.1,"sec")',perc1,time1-time0
    print,"... having read ",idat1," model parameters, species masses & temps."
  endif  
  close,1

  ;--------- read MasterSED ---------  
  Nlam = 0
  openr,1, folder+"/MasterSED.dat"
  readf,1,header
  readf,1,header
  readf,1,format='(A32,I,I)',header,Nlam,Nincl1
  lamcont = fltarr(Nlam) 
  Fcont = fltarr(Nmod,Nincl1,Nlam) 
  Fcont(*,*,*) = !VALUES.F_NAN
  alphaSED = fltarr(Nmod,Nincl1) 
  alphaSED(*,*) = !VALUES.F_NAN
  beta_abs = fltarr(Nmod,Ngas)
  beta_abs(*,*) = !VALUES.F_NAN
  Fval  = fltarr(Nlam) 
  incl1 = fltarr(Nincl1) 
  readf,1,lamcont
  readf,1,incl1
  if (unform EQ 0) then begin
    print,"reading "+folder+"/MasterSED.dat ..."
    readf,1,header
    readf,1,header
    idat2=0L
    incl=0
    time0=systime(1)
    perc0=0.0
    while (~EOF(1)) do begin
      readf,1, id,incl,Fval
      id=id-1
      idat2=idat2+1
      Fcont(id,incl,*) = Fval(*) 
      perc1 = idat2*100.0/totread2
      if (perc1 GT perc0+10.0) then begin
        perc0=perc1
        time1=systime(1)
        print,format='(F5.1,"% time=",F5.1,"sec")',perc1,time1-time0
      endif  
    endwhile
    perc1 = idat2*100.0/totread2
    time1 = systime(1)
    print,format='(F5.1,"% time=",F5.1,"sec")',perc1,time1-time0
    print,"... having read ",idat2," SEDs"
    ind = WHERE(lamcont GT 800 AND lamcont LT 4000)
    xx  = ALOG(lamcont(ind))
    id=0L
    reject=0L
    taken=0L
    repeat begin
      for j=0,Nincl1-1 do begin
        yy = ALOG(Fcont(id,j,ind))
        if (FINITE(yy[0])) then begin
          coeff = LINFIT(xx,yy,SIGMA=sigma)
          alphaSED(id,j) = -coeff[1] - 2.0
          if (sigma[1] GT 0.1) then begin   ; avoid models with lots of scatter
            alphaSED(id,j) = !VALUES.F_NAN   ; treat as missing data
            reject = reject+1
          endif else begin
            taken = taken+1 
          endelse
          ;yfit = coeff[0]+xx*coeff[1]
          ;print,format='(i5,i2,99(F6.3),3x,3(F6.3))',$
          ;      id,j,yy-yfit,STDDEV(yy-yfit),sigma(1),var(id,j)
        endif
      endfor
      id = id+1
    endrep until (id EQ Nmod)      
    print,format='("computed beta_SED: taken=",I7," rejected=",I6)',$
          taken,reject
  endif
  close,1

  ;--------- read MasterLine ---------  
  Nlines = 0
  openr,1, folder+"/MasterLine.dat"
  readf,1,header
  readf,1,header
  readf,1,format='(A32,I,I)',header,Nlines,Nincl2
  incl2 = fltarr(Nincl2)
  readf,1,incl2
  LineName = strarr(Nlines)
  LineFlux = fltarr(Nlines,Nmod,Ngas,Nincl2)     
  LineFlux(*,*,*,*) = !VALUES.F_NAN
  readf,1,header
  readf,1,header
  NEXTWORD,header,word
  NEXTWORD,header,word
  Nname=0
  while (STRLEN(header) GT 0) do begin
    NEXTWORD,header,word
    LineName(Nname)=word
    Nname=Nname+1
  endwhile

  if (unform EQ 0) then begin
    print,"reading "+folder+"/MasterLine.dat ..."
    if (basenr EQ 1) then begin
      form='(I5.5,1x,I1,I5,99(E12.4))'
    endif
;    if (basenr EQ 2) then begin
;      form='(1x,I5.5,I1,I5,99(E12.4))'
;    endif
; change 3 to 2
    if (basenr EQ 2) then begin
      form='(I5.5,1x,I1,I5,99(E12.4))'
    endif
    time0=systime(1)
    perc0=0.0
    val = fltarr(Nname)
    idat3 = 0L
    while (~EOF(1)) do begin
      readf,1,format=form,id,igas,incl,val
      id=id-1
      igas=igas-1
      LineFlux(*,id,igas,incl) = val(*)
      idat3=idat3+1
      perc1 = idat3*100.0/totread3
      if (perc1 GT perc0+10.0) then begin
        perc0=perc1
        time1=systime(1)
        print,format='(F5.1,"% time=",F5.1,"sec")',perc1,time1-time0
      endif  
    endwhile
    perc1 = idat2*100.0/totread2
    time1 = systime(1)
    print,format='(F5.1,"% time=",F5.1,"sec")',perc1,time1-time0
    print,"... having read ",idat3," line fluxes."
  endif
  close,1

  ;------ dump data into unfomatted file ----------
  if (unform EQ 0) then begin
    print,"now writing "+folder+"/Master.dat for next time ..."   
    openw,2,folder+"/Master.dat"
    writeu,2, modelID, Mdust, alphaSED, ParaVal,$
      lamcont, Fcont, incl1, incl2, LineFlux     
  endif else begin
    openr,2,folder+"/Master.dat"
    readu,2, modelID, Mdust, alphaSED, ParaVal,$
      lamcont, Fcont, incl1, incl2, LineFlux 
    print,"... done."
    sel = WHERE(FINITE(ParaVal(0,*,*)), idat1)
    sel = WHERE(FINITE(Fcont(*,*,0)), idat2)
    sel = WHERE(FINITE(LineFlux(0,*,*,*)), idat3)
  endelse
  close,2

  ;------ suppress faulty low-mass models ------ 
  ;modsel = WHERE(M_OI/Mdisk GT 4.E-3) 
  ;Mdisk(modsel) = M_OI(modsel)/4.E-3
  ;OI_63(modsel,*) = 0.0 
  ;CO_2600(modsel,*) = 0.0 

  ;------ fill in ages -------
; change 3 to 2
  if (basenr EQ 2) then begin
    ; modelID                      :: 11 ... 648005
    ; id      = modelID/10-1       ::  0 ... 64800-1
    ; RinID   = id / 21600         ::  0 ... 2
    ; rest1   = id MOD 21600       ::  0 ... 21600-1
    ; MstarID = rest1    /   4320  ::  0 ... 4
    ; rest2   = rest1   MOD  4320  ::  0 ... 4320-1
    ; ageID   = rest2    /   1080  ::  0 ... 3
    id = modelID(*,*)/10-1   
    ageID = ((id MOD 21600) MOD 4320 ) / 1080
    ageID(WHERE(id EQ -1)) = -1          
    age(WHERE(ageID EQ 0)) = 1.0
    age(WHERE(ageID EQ 1)) = 3.0  
    age(WHERE(ageID EQ 2)) = 10.0  
    age(WHERE(ageID EQ 3)) = 100.0
  endif

  ;------ fill beta_abs -------
  if (basenr EQ 1) then begin
    ind = WHERE(strpos(ParaName,'apow') GE 0,count)
    if (count EQ 1) then begin
      vtmp = fltarr(Nmod,Ngas)
      vtmp(*,*) = ParaVal(ind,*,*)
      beta_abs(where(vtmp EQ 4.05)) = 1.46 
      beta_abs(where(vtmp EQ 3.80)) = 1.23 
      beta_abs(where(vtmp EQ 3.65)) = 1.09 
      beta_abs(where(vtmp EQ 3.50)) = 0.95 
      beta_abs(where(vtmp EQ 3.35)) = 0.84
    endif
 endif
; change 3 to 2
  if (basenr EQ 2) then begin
    beta_abs(*,*) = 1.6725 
  endif
  
  ;------ now adjust labels and combo boxes -------
  ind = WHERE(strpos(ParaName,"Rin") GE 0)
  Rin = fltarr(Nmod,Ngas) 
  Rin(*,*) = ParaVal(ind,*,*)
  RinSave = Rin
; change 3 to 2
  if (basenr EQ 2) then begin
    N1 = Nmod/3
    N2 = 2*N1
    N3 = Nmod
    Rin( 0:N1-1,*)=1.0          ;   1*sublimation radius
    Rin(N1:N2-1,*)=10.0         ;  10*sublimation radius
    Rin(N2:N3-1,*)=100.0        ; 100*sublimation radius
    ParaVal(ind,*,*) = Rin(*,*)
    WIDGET_CONTROL,label12,set_value="Rin[Rsubli]"
  endif else begin
    WIDGET_CONTROL,label12,set_value="Rin[AU]    "
  endelse
  text1 = STRING(format='(I7)',idat1)+" disk models,"
  text2 = STRING(format='(I7)',idat2)+" SEDs,"
  text3 = STRING(format='(I7)',idat3)+" line fluxes"
  WIDGET_CONTROL, label1, SET_VALUE=text1
  WIDGET_CONTROL, label2, SET_VALUE=text2
  WIDGET_CONTROL, label3, SET_VALUE=text3
  vals = strarr(300)
  for quan=1,19 do begin
    if (quan EQ 1) then begin
      ind=WHERE(strpos(ParaName,"Mstar") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_Mstar
      form='(F9.1)'
    endif  
    if (quan EQ 2) then begin
      val=age
      combo=combo_age
      form='(F9.2)'
    endif  
    if (quan EQ 3) then begin
      ind=WHERE(strpos(ParaName,"Teff") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_Teff
      form='(F9.1)'
    endif  
    if (quan EQ 4) then begin
      ind=WHERE(strpos(ParaName,"Lstar") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_Lstar
      form='(F12.6)'
    endif  
    if (quan EQ 5) then begin
      ind=WHERE(strpos(ParaName,"fUV") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_fUV
      form='(F9.3)'
    endif
    if (quan EQ 6) then begin
      ind=WHERE(strpos(ParaName,"Mgas") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_Mdisk
      form='(E9.1)'
    endif
    if (quan EQ 7) then begin
      val=Mdust
      combo=combo_Mdust
      form='(E9.1)'
    endif
    if (quan EQ 8) then begin
      ind=WHERE(strpos(ParaName,"dust/gas") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_dustgas
      form='(F9.3)'
    endif
    if (quan EQ 9) then begin
      val=Rin
      combo=combo_Rin
      form='(F11.5)'
    endif
    if (quan EQ 10) then begin
      ind=WHERE(strpos(ParaName,"Rout") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_Rout
      form='(F9.3)'
    endif
    if (quan EQ 11) then begin
      ind=WHERE(strpos(ParaName,"H0") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_H0
      form='(F9.3)'
    endif
    if (quan EQ 12) then begin
      ind=WHERE(strpos(ParaName,"epsilon") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_epsilon
      form='(F9.3)'
    endif
    if (quan EQ 13) then begin
      ind=WHERE(strpos(ParaName,"beta") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_beta
      form='(F9.3)'
    endif
    if (quan EQ 14) then begin
      ind=WHERE(strpos(ParaName,"amin") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_amin
      form='(F9.3)'
    endif
    if (quan EQ 15) then begin
      ind=WHERE(strpos(ParaName,"amax") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_amax
      form='(F9.1)'
    endif
    if (quan EQ 16) then begin
      val = 3.5
      ind=WHERE(strpos(ParaName,"apow") ge 0,count) 
      if (count EQ 1) then val=ParaVal(ind,*,*)
      combo=combo_apow
      form='(F9.3)'
    endif
    if (quan EQ 17) then begin
      ind=WHERE(strpos(ParaName,"settle") ge 0) 
      val=ParaVal(ind,*,*)
      combo=combo_settle
      form='(F9.3)'
      if (basenr EQ 1) then form='(E9.1)'
    endif
    if (quan EQ 18) then begin
      val=incl1
      combo=combo_incl
;      form='(F9.3)'
; inclination selection did not work properly with less digits
      form='(F9.4)'
    endif
    if (quan EQ 19) then begin
      combo=combo_igas
      form='(I1)'
    endif
    vals(0)='all'
    Nvals=0
    for it=1,299 do begin
      vmax = max(val)
      if (vmax EQ -99.9) then break
      ;print,it,Nvals,vals(0:Nvals)
      ;print,val
      Nvals=Nvals+1
      vals(Nvals) = STRTRIM(STRING(format=form,vmax),2)
      val(WHERE(val GE 0.999999*vmax)) = -99.9
    endfor
;    if ((basenr EQ 2) AND (combo EQ combo_incl)) then begin
;      nr=5  
;      tmp=vals(nr)
;      for i=nr+1,Nvals-1 do begin
;        vals(i-1)=vals(i)
;      endfor  
;      vals(Nvals-1)=tmp
;    endif  
    if (combo EQ combo_igas) then begin
;      if (basenr EQ 2) then begin
;        Nvals = 2
;        vals(1) = '2'
;        vals(2) = '4'
;      endif
; change 3 to 2
      if (basenr EQ 2) then begin
        Nvals = 5
        vals(1)='1'
        vals(2)='2'
        vals(3)='3'
        vals(4)='4'
        vals(5)='5'
      endif
    endif
    Nvals=Nvals+1 
    vals(Nvals)='input'
    print,quan,Nvals,vals(0:Nvals)
    WIDGET_CONTROL, combo, SET_VALUE=vals(0:Nvals)
    WIDGET_CONTROL, combo, SET_COMBOBOX_SELECT=Nvals+1
  endfor  

  ; ---  default selection  ---
  sel_models = intarr(Nmod,Ngas)
  sel_SEDs   = intarr(Nmod,Nincl1)
  sel_lines  = intarr(Nmod,Ngas,Nincl2)
  sel_models(*,*)  = 1
  sel_SEDs(*,*)    = 1
  sel_lines(*,*,*) = 1
  dum1=ParaVal(0,*,*)
  dum2=Fcont(*,*,0)    
  dum3=LineFlux(0,*,*,*)
  sel_models(WHERE(~FINITE(dum1), /null)) = 0
  sel_SEDs  (WHERE(~FINITE(dum2), /null)) = 0
  sel_lines (WHERE(~FINITE(dum3), /null)) = 0

  ; ---  list of variables to choose from  ---
  NP = N_ELEMENTS(ParaName)+4
  Pname = strarr(NP)
  Pname(0) = 'none'
  Pname(1) = 'model_ID'
  Pname(2) = 'incl'
  ind=WHERE(strpos(ParaName,"Mgas") ge 0) 
  Pname(3:ind+3) = ParaName(0:ind)
  Pname(ind+4)   = "Mdust[Msun]"
  Pname(ind+5:NP-1) = ParaName(ind+1:NP-5)
  Cname = ['Fcont(0.55mic)','Fcont(0.70mic)','Fcont(0.90mic)',$
           'Fcont(1.2mic)','Fcont(1.66mic)','Fcont(2.2mic)','Fcont(3.7mic)',$
           'Fcont(4.5mic)','Fcont(5.8mic)','Fcont(8.0mic)','Fcont(24mic)',$
           'Fcont(70mic)','Fcont(160mic)','Fcont(210mic)','Fcont(320mic)',$
           'Fcont(850mic)','Fcont(1300mic)','Fcont(3500mic)',$
           'beta_abs','alpha_SED']
  NC = N_ELEMENTS(Cname)
  varname = STRARR(NP+NC+Nlines)
  varname(0    :NP-1)           = Pname(0:NP-1)
  varname(NP   :NP+NC-1)        = Cname(0:NC-1)
  varname(NP+NC:NP+NC+Nlines-1) = LineName(0:Nlines-1)
  Nvars = N_ELEMENTS(varname)

  istart = where(strpos(varname,"M_") GE 0)
  filtername = strarr(Nvars-istart(0)+1)
  filtername(0) = 'none'
  filtername(1:Nvars-istart(0)) = varname(istart(0):Nvars-1)

  print, LineName

END; READDATA

