
;----------------------------
; ***  define x/y/z-axis  ***
;----------------------------
PRO SELECT_AXIS, name

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  axis = name

  if (axis EQ 'x') then begin
    sel1 = WHERE(xvar1 EQ varname)
    sel2 = WHERE(xvar2 EQ varname)
    log  = xlog 
    mintext = xminval
    maxtext = xmaxval
  endif
  if (axis EQ 'y') then begin
    sel1 = WHERE(yvar1 EQ varname)
    sel2 = WHERE(yvar2 EQ varname)
    log  = ylog 
    mintext = yminval
    maxtext = ymaxval
  endif
  if (axis EQ 'z') then begin
    sel1 = WHERE(zvar1 EQ varname)
    sel2 = WHERE(zvar2 EQ varname)
    log  = zlog 
    mintext = zminval
    maxtext = zmaxval
  endif

  print,"select the "+name+"-axis ..."
  selectbase = WIDGET_BASE(TITLE="select the "+name+"-axis")
  label1 = WIDGET_LABEL(selectbase, VALUE='variable', $
                        XOFFSET=5, YOFFSET=5, /ALIGN_LEFT)
  label2 = WIDGET_LABEL(selectbase, VALUE='divided by ...', $
                        XOFFSET=155, YOFFSET=5, /ALIGN_LEFT)
  selectID1 = WIDGET_LIST(selectbase,VALUE=varname,$
                        SCR_XSIZE=120,SCR_YSIZE=180,$
                        XOFFSET=0,YOFFSET=25)
  selectID2 = WIDGET_LIST(selectbase,VALUE=varname,$
                        SCR_XSIZE=120,SCR_YSIZE=180,$
                        XOFFSET=150,YOFFSET=25)
  label3 = WIDGET_LABEL(selectbase, VALUE='min', $
                        XOFFSET=5, YOFFSET=215, /ALIGN_LEFT)
  label4 = WIDGET_LABEL(selectbase, VALUE='max', $
                        XOFFSET=155, YOFFSET=215, /ALIGN_LEFT)
  minedit = WIDGET_TEXT(selectbase,/EDITABLE,value=mintext, $
                        XSIZE=12, XOFFSET=1, YOFFSET=232)
  maxedit = WIDGET_TEXT(selectbase,/EDITABLE,value=maxtext, $
                        XSIZE=12, XOFFSET=151, YOFFSET=232)
  selectlog = CW_BGROUP(selectbase, ["lin","log"], /COLUMN, /EXCLUSIVE, $  
                        LABEL_TOP='lin/log', /FRAME,$
                        XOFFSET=290,YOFFSET=5)
  selectdone = WIDGET_BUTTON(selectbase, VALUE='done', UVALUE= 'done', $
                        XOFFSET=290, YOFFSET=225,$
                        XSIZE=60,YSIZE=40)
  WIDGET_CONTROL, selectID1, SET_LIST_SELECT=sel1
  WIDGET_CONTROL, selectID2, SET_LIST_SELECT=sel2
  WIDGET_CONTROL, selectlog, SET_VALUE=log
  WIDGET_CONTROL, selectbase, XSIZE=360,YSIZE=270,$
                  XOFFSET=0,YOFFSET=500, /Realize
  XMANAGER, 'xSelect',selectbase, /NO_BLOCK  
END 
