
;-------------------------------------------
; ***  make a sub-selection of the data  ***
;-------------------------------------------
PRO SELECT_DATA

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME
               
  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON selection, sel_models,sel_SEDs,sel_lines
  COMMON fits, ID_best,gas_best,incl1_best,incl2_best,chi_best 
  COMMON SEDplot, Nplotted,Fmin,Fmax 

; corrected where statements according to new syntax in IDL (negative
; indices have meaning) 

  ; ---  default selection  ---
  sel_models = intarr(Nmod,Ngas)
  sel_SEDs   = intarr(Nmod,Nincl1)
  sel_lines  = intarr(Nmod,Ngas,Nincl2)
  dum1       = fltarr(Nmod,Ngas)
  dum2       = fltarr(Nmod,Nincl1)
  dum3       = fltarr(Nmod,Ngas,Nincl2)
  sel_models(*,*)  = 1
  sel_SEDs(*,*)    = 1
  sel_lines(*,*,*) = 1
  dum1(*,*)=ParaVal(0,*,*)
  dum2(*,*)=Fcont(*,*,0)
  dum3(*,*,*)=LineFlux(0,*,*,*)
  sel_models(WHERE(~Finite(dum1), /null)) = 0
  sel_SEDs  (WHERE(~Finite(dum2), /null)) = 0
  sel_lines (WHERE(~Finite(dum3), /null)) = 0
  i=0L
  repeat begin
    if (dum1(i,0) LE 0.0) then sel_SEDs(i,*)=0                
    for j=0,Ngas-1 do begin
      if (dum1(i,j) LE 0.0) then sel_lines(i,j,*)=0                
    endfor
    i=i+1
  endrep until (i EQ Nmod)

  ; ---  select data according to text in comboboxes ---
  tmp = fltarr(Nmod,Ngas)
  seltext=WIDGET_INFO(combo_Mstar,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'Mstar') GE 0),*,*),"Mstar_val"
  
  seltext=WIDGET_INFO(combo_age,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,age,"age_val"  

  seltext=WIDGET_INFO(combo_Teff,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'Teff') GE 0),*,*),"Teff_val"  

  seltext=WIDGET_INFO(combo_Lstar,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'Lstar') GE 0),*,*),"Lstar_val"

  seltext=WIDGET_INFO(combo_fUV,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'fUV') GE 0),*,*),"fUV_val"

  seltext=WIDGET_INFO(combo_Mdisk,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'Mgas') GE 0),*,*),"Mdisk_val"

  seltext=WIDGET_INFO(combo_Mdust,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,Mdust,"Mdust_val"

  seltext=WIDGET_INFO(combo_dustgas,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'dust/gas') GE 0),*,*),"dust/gas"

  seltext=WIDGET_INFO(combo_Rin,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'Rin') GE 0),*,*),"Rin_val"

  seltext=WIDGET_INFO(combo_Rout,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'Rout') GE 0),*,*),"Rout_val"

  seltext=WIDGET_INFO(combo_H0,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'H0') GE 0),*,*),"H0_val"

  seltext=WIDGET_INFO(combo_epsilon,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'epsilon') GE 0),*,*),"epsilon_val"

  seltext=WIDGET_INFO(combo_beta,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'beta') GE 0),*,*),"beta_val"

  seltext=WIDGET_INFO(combo_amin,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'amin') GE 0),*,*),"amin_val"

  seltext=WIDGET_INFO(combo_amax,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'amax') GE 0),*,*),"amax_val"

; apow is not a parameter in the DENT grid basenr=2
  seltext=WIDGET_INFO(combo_apow,/COMBOBOX_GETTEXT)
;  if (seltext NE 'all') then READ_VAL,seltext,$
  if (seltext NE 'all' and basenr ne 2) then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'apow') GE 0),*,*),"apow_val"

  seltext=WIDGET_INFO(combo_settle,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then READ_VAL,seltext,$
     ParaVal(WHERE(strpos(ParaName,'settle') GE 0),*,*),"settle_val"

  ; --- deselect models if model ID or igas specified ---

  WIDGET_CONTROL, text_ID, GET_VALUE=id
  if ((STRTRIM(id,2) NE '') AND (STRTRIM(id,2) NE 'all')) then begin
    contr = strmid(id,0,2)
    ok = 0
    if (contr EQ '>=') then begin
      id = LONG(strmid(id,2))
      id = id(0)
      ind = WHERE(modelID/10 LT id, count)
      if (count gt 0) then sel_models(ind,*) = 0
      ;sel_lines(ind,*,*) = 0
      ;sel_SEDs(ind,*) = 0
      ok=1 
    endif else if (contr EQ '<=') then begin
      id = LONG(strmid(id,2))
      id = id(0)
      ind = WHERE(modelID/10 GT id, count)
      if (count gt 0) then sel_models(ind,*) = 0
      ;sel_lines(ind,*,*) = 0
      ;sel_SEDs(ind,*) = 0
      ok=1 
    endif else begin
      id = LONG(id)
      id = id(0)
      if ((id GE 1) AND (id LE Nmod)) then begin
        ind = WHERE(modelID/10 NE id, count)
        if (count gt 0) then sel_models(ind,*) = 0
        ;sel_lines(ind,*,*) = 0
        ;sel_SEDs(ind,*) = 0
        ok=1
      endif
    endelse 
    if (ok EQ 0) then begin
      print, " *** invalid model ID: please choose value between 1 and ", $
             STRING(Nmod,FORMAT='(I5)')
      print, " *** or say '<= number' or '>= number'"
    endif
  endif
  seltext=WIDGET_INFO(combo_igas,/COMBOBOX_GETTEXT)
  if (seltext NE 'all') then begin
    if (STRPOS(seltext,'<=') NE -1) then begin
      tmp = STRMID(seltext,2)
      reads,tmp,val
      val = LONG(val)
      if (val LE Ngas-1) then sel_models(*,val:Ngas-1) = 0
      ;sel_lines(*,val:Ngas-1,*) = 0
      print,"selection igas_val <= ",val
    endif
    if (STRPOS(seltext,'>=') NE -1) then begin
      tmp = STRMID(seltext,2)
      reads,tmp,val
      val = LONG(val)
      if (val GE 2) then sel_models(*,0:val-2) = 0
      ;sel_lines(*,0:val-2,*)= 0
      print,"selection igas_val >= ",val
    endif 
    if (STRPOS(seltext,'--')  NE -1) then begin
      ind = STRPOS(seltext,'--')
      tmp = STRMID(seltext,0,ind)                   
      reads,tmp,val1
      tmp = STRMID(seltext,ind+2)
      reads,tmp,val2
      if (val2 LT val1) then begin                ;make sure val1 < val2
        tmp  = val2
        val2 = val1
        val1 = tmp
      endif
      val1 = LONG(val1)
      val2 = LONG(val2)
      if (val1 GE 2) then sel_models(*,0:val1-2) = 0
      ;sel_lines(*,0:val1-2,*)= 0
      if (val2 LE Ngas-1) then sel_models(*,val2:Ngas-1) = 0
      ;sel_lines(*,val2:Ngas-1,*) = 0
      print,"selection igas_val ", val1, "   -", val2
    endif
    if (STRPOS(seltext,'<=') EQ -1 AND $
        STRPOS(seltext,'>=') EQ -1 AND $
        STRPOS(seltext,'--') EQ -1) then begin
      reads,seltext,val
      val = LONG(val)
      if (val GE 2) then sel_models(*,0:val-2) = 0
      ;sel_lines(*,0:val-2,*)= 0
      if (val LE Ngas-1) then sel_models(*,val:Ngas-1) = 0
      ;sel_lines(*,val:Ngas-1,*) = 0
      print,"selection igas_val = ",val
    endif
  endif
  

  ; --- deselect Fline and Fcont data if model is not selected ---
  id=0L
  repeat begin
    any_gas=0
    for igas=0,Ngas-1 do begin
      if (sel_models(id,igas) EQ 1) then begin
        any_gas=1 
      endif else begin 
        sel_lines(id,igas,*)=0
      endelse
    endfor
    if (any_gas EQ 0) then sel_SEDs(id,*)=0 
    id=id+1
  endrep until (id EQ Nmod)

  ; --- select inclination by taking nearest value ---
  seltext=WIDGET_INFO(combo_incl,/COMBOBOX_GETTEXT)
  i1best=1
  i2best=1
  if (seltext NE 'all') then begin
    if (STRPOS(seltext,'<=') NE -1) then begin
      val=0.
      tmp = STRMID(seltext,2)
      reads,tmp,val
      ind = WHERE(incl1 GT val, count)
      if (count gt 0) then sel_SEDs(*,ind)=0
      print, val, count
      ind = WHERE(incl2 GT val, count)
      if (count gt 0) then sel_lines(*,*,ind)=0
      print,"selection incl_val <= ",val
    endif 
    if (STRPOS(seltext,'>=') NE -1) then begin
      val=0.
      tmp = STRMID(seltext,2)
      reads,tmp,val
      ind = WHERE(incl1 LT val, count)
      if (count gt 0) then sel_SEDs(*,ind)=0
      ind = WHERE(incl2 LT val, count)
      if (count gt 0) then sel_lines(*,*,ind)=0
      print,"selection incl_val >= ",val
    endif 
    if (STRPOS(seltext,'--')  NE -1) then begin
      val1=0.
      val2=0.
      ind = STRPOS(seltext,'--')
      tmp = STRMID(seltext,0,ind)                   
      reads,tmp,val1
      tmp = STRMID(seltext,ind+2)
      reads,tmp,val2
      if (val2 LT val1) then begin                ;make sure val1 < val2
        tmp  = val2
        val2 = val1
        val1 = tmp
      endif
      ind = WHERE(incl1 LT val1, count)
      if (count gt 0) then sel_SEDs(*,ind)=0
      ind = WHERE(incl1 GT val2, count)
      if (count gt 0) then sel_SEDs(*,ind)=0
      ind = WHERE(incl2 LT val1, count)
      if (count gt 0) then sel_lines(*,*,ind)=0
      ind = WHERE(incl2 GT val2, count)
      if (count gt 0) then sel_lines(*,*,ind)=0
      print,"selection incl_val ", val1, "   -", val2
    endif
    if (STRPOS(seltext,'<=') EQ -1 AND $
        STRPOS(seltext,'>=') EQ -1 AND $
        STRPOS(seltext,'--') EQ -1) then begin
      reads,seltext,val
      print,"selection incl_val = ",val
      ibest=0.0
      qbest=99.9
      for ii=0,Nincl2-1 do begin
        qual=ABS(incl2(ii)-val)
        if (qual LT qbest) then begin
          qbest=qual
          ibest=incl2(ii)
          i2best=ii
        endif
      endfor
      ind=WHERE(ABS(incl2-ibest) GT 0.001, count)
      if (count gt 0) then sel_lines(*,*,ind)=0
      ibest=0.0
      qbest=99.9
      for ii=0,Nincl1-1 do begin
        qual=ABS(incl1(ii)-val)
        if (qual LT qbest) then begin
          qbest=qual
          ibest=incl1(ii)
          i1best=ii
        endif
      endfor
      ind=WHERE(ABS(incl1-ibest) GT 0.001, count)
      if (count gt 0) then sel_SEDs(*,ind)=0
    endif
  endif


  dum1 = WHERE(sel_models EQ 1, count)
  print, count," disk models selected"
  dum1 = WHERE(sel_SEDs EQ 1, count)
  print, count," SEDs selected"
  dum1 = WHERE(sel_lines EQ 1, count)
  print, count," line fluxes selected"

  ; ---  fill in "best"-arrays to enable SED plotting ---
  Nplotted=0
  ID_best(*)=-1
  i=0
  id=0L
  igas1=0
  igas2=4
  ; ---  take only dust/gas=0.01 models if not selected  ---
  seltext1=WIDGET_INFO(combo_dustgas,/COMBOBOX_GETTEXT)
  seltext2=WIDGET_INFO(combo_igas,/COMBOBOX_GETTEXT)
  if ((seltext1 EQ 'all') AND (seltext2 EQ 'all'))then begin
    igas1=min([1,Ngas-1])
    igas2=min([1,Ngas-1])
  endif
  repeat begin
    for igas=igas1,igas2 do begin  
      if (sel_models(id,igas) AND sel_SEDs(id,i1best)) then begin
        ID_best(i)=id
        gas_best(i)=igas
        incl1_best(i)=i1best
        incl2_best(i)=i2best
        chi_best(i)=0.0
        print,format='("selected model #",I5.5," igas=",I1," incl=",F8.3)',$
              id+1,igas+1,incl1(i1best)
        i=i+1
        if (i GT 9) then break
      endif
    endfor
    if (i GT 9) then break
    id=id+1
  endrep until (id EQ Nmod)

END; SELECT_DATA

