
;---------------------------------------------------
; ***  event handler routine for axis selection  ***
;---------------------------------------------------
PRO xSelect_event, ev
  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  ;print,axis,ev.ID,selectID1,selectID2,selectdone
  if (ev.ID EQ selectID1) then begin
    var=varname(ev.index)
    if (axis EQ 'x') then xvar1=var
    if (axis EQ 'y') then yvar1=var
    if (axis EQ 'z') then zvar1=var
  endif    
  if (ev.ID EQ selectID2) then begin
    var=varname(ev.index)
    if (axis EQ 'x') then xvar2=var
    if (axis EQ 'y') then yvar2=var
    if (axis EQ 'z') then zvar2=var
  endif    
  if (ev.ID EQ selectdone) then begin
    ; --- pressed "done" for selection of x/y/z-axis ---
    if (axis EQ 'x') then WIDGET_CONTROL, selectlog, GET_VALUE=xlog
    if (axis EQ 'y') then WIDGET_CONTROL, selectlog, GET_VALUE=ylog
    if (axis EQ 'z') then WIDGET_CONTROL, selectlog, GET_VALUE=zlog
    if (axis EQ 'x') then begin
      WIDGET_CONTROL, minedit, GET_VALUE=xminval
      WIDGET_CONTROL, maxedit, GET_VALUE=xmaxval
    endif  
    if (axis EQ 'y') then begin
      WIDGET_CONTROL, minedit, GET_VALUE=yminval
      WIDGET_CONTROL, maxedit, GET_VALUE=ymaxval
    endif  
    if (axis EQ 'z') then begin
      WIDGET_CONTROL, minedit, GET_VALUE=zminval
      WIDGET_CONTROL, maxedit, GET_VALUE=zmaxval
    endif  
    if (axis EQ 'x') then print, "selected x-axis: """,xvar1,$
                                 "/",xvar2,""" log="+STRTRIM(STRING(xlog),2)
    if (axis EQ 'y') then print, "selected y-axis: """,yvar1,$
                                 "/",yvar2,""" log="+STRTRIM(STRING(ylog),2)
    if (axis EQ 'z') then print, "selected z-axis: """,zvar1,$
                                 "/",zvar2,""" log="+STRTRIM(STRING(zlog),2)
    WIDGET_CONTROL, selectbase, /DESTROY  
  endif    
END

;---------------------------------------------------
; ***  event handler routine for colour selection  ***
;---------------------------------------------------
PRO xColour_event, ev
  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  if (ev.ID EQ selectID1) then cname1=varname(ev.index)
  if (ev.ID EQ selectID2) then cname2=varname(ev.index)
  if (ev.ID EQ selectncolour) then ncolour = ev.index+1
  if (ev.ID EQ selectdone) then begin
    ; --- pressed "done" for color selection ---
    WIDGET_CONTROL, minedit, GET_VALUE=cminval
    WIDGET_CONTROL, maxedit, GET_VALUE=cmaxval
    WIDGET_CONTROL, selectlog, GET_VALUE=clog
    print, "change colours for: """,cname1,"/",cname2,$
           """ log="+STRTRIM(STRING(clog),2),""" ncolour="+STRTRIM(STRING(ncolour),2)
    WIDGET_CONTROL, selectbase, /DESTROY  
  endif    
END

;---------------------------------------------------
; ***  event handler routine for filters selection  ***
;---------------------------------------------------
PRO xFilters_event, ev
  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  if (ev.ID EQ select1) then fvar1 = filtername(ev.index)
  if (ev.ID EQ select2) then fvar2 = filtername(ev.index)
  if (ev.ID EQ select3) then fvar3 = filtername(ev.index)
  if (ev.ID EQ select4) then fvar4 = filtername(ev.index)  
  if (ev.ID EQ selectreset) then begin
    WIDGET_CONTROL, select1, SET_LIST_SELECT=0 
    WIDGET_CONTROL, select2, SET_LIST_SELECT=0
    WIDGET_CONTROL, select3, SET_LIST_SELECT=0
    WIDGET_CONTROL, select4, SET_LIST_SELECT=0
    WIDGET_CONTROL, minedit1, SET_VALUE='auto'
    WIDGET_CONTROL, maxedit1, SET_VALUE='auto'
    WIDGET_CONTROL, minedit2, SET_VALUE='auto'
    WIDGET_CONTROL, maxedit2, SET_VALUE='auto'
    WIDGET_CONTROL, minedit3, SET_VALUE='auto'
    WIDGET_CONTROL, maxedit3, SET_VALUE='auto'
    WIDGET_CONTROL, minedit4, SET_VALUE='auto'
    WIDGET_CONTROL, maxedit4, SET_VALUE='auto'
    fvar1='none' & fvar2='none' & fvar3='none' & fvar4='none'
  endif
  if (ev.ID EQ selectdone) then begin
    WIDGET_CONTROL, minedit1, GET_VALUE=fmin1
    WIDGET_CONTROL, maxedit1, GET_VALUE=fmax1
    WIDGET_CONTROL, minedit2, GET_VALUE=fmin2
    WIDGET_CONTROL, maxedit2, GET_VALUE=fmax2
    WIDGET_CONTROL, minedit3, GET_VALUE=fmin3
    WIDGET_CONTROL, maxedit3, GET_VALUE=fmax3
    WIDGET_CONTROL, minedit4, GET_VALUE=fmin4
    WIDGET_CONTROL, maxedit4, GET_VALUE=fmax4
    print, "only plot models with values in range:"
    if (fvar1 NE 'none') then print, FORMAT='(A14, " = [", A8,",",A8," ]")', $
                                     fvar1,fmin1,fmax1
    if (fvar2 NE 'none') then print, FORMAT='(A14, " = [", A8,",",A8," ]")', $
                                     fvar2,fmin2,fmax2
    if (fvar3 NE 'none') then print, FORMAT='(A14, " = [", A8,",",A8," ]")', $
                                     fvar3,fmin3,fmax3
    if (fvar4 NE 'none') then print, FORMAT='(A14, " = [", A8,",",A8," ]")', $
                                     fvar4,fmin4,fmax4
    
    WIDGET_CONTROL, selectbase, /DESTROY
  endif
END

PRO PLOT_CLOSED, wChild 
  COMMON window, Wlist
  print,"closing plot-window",wChild  
  for i=0,99 do begin
    if (Wlist(i) EQ wChild) then begin
      Wlist(i) = 0
      break
    endif
  endfor
  ; Make sure we have a valid widget ID.  
  IF (~WIDGET_INFO(wChild, /VALID)) THEN RETURN    
  ; Retrieve the pointer to the state structure, and free it.  
  WIDGET_CONTROL, wChild, GET_UVALUE = pState  
  IF (PTR_VALID(pState)) THEN PTR_FREE,pState  
END

PRO SAVE_GIF
  print,"saving last window graph to ..."
  filename=DIALOG_PICKFILE(/READ, FILE='out.gif', FILTER='*.gif')
  if (filename EQ '') then return   ; cancel pressed
  a = tvrd(TRUE=1) 
  image = color_quan(a, 1, red, green, blue)
  write_gif, filename, image, red, green, blue
  print,"... written graphical output to "+filename
END

;--------------------------------------------------
; ***  event handler routine for plot2d_models  ***
;--------------------------------------------------
PRO plot2d_event, ev

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  if (ev.press EQ 1) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    POINT_INFO, ev.x, ev.y,dist
  endif
END  


;------------------------------------------
; ***  event handler routine for xDENT  ***
;------------------------------------------
PRO xDENT_event, ev  

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs,Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON fits, ID_best,gas_best,incl1_best,incl2_best,chi_best 

  COMMON output, pswrite, datwrite
  COMMON window, Wlist

  ; --- close button pressed ---
  if (ev.ID eq fileExit) then begin
    WIDGET_CONTROL, ev.top, /DESTROY  
  endif

  ; --- database selection ---
;  if ((ev.ID eq dataset1) OR (ev.ID eq dataset2) OR $
;      (ev.ID eq dataset3)) then begin 
  if ((ev.ID eq dataset1) OR (ev.ID eq dataset2)) then begin 
    WIDGET_CONTROL, dataset1, SET_BUTTON=0  
    WIDGET_CONTROL, dataset2, SET_BUTTON=0  
;    WIDGET_CONTROL, dataset3, SET_BUTTON=0  
    WIDGET_CONTROL, ev.ID, /SET_BUTTON  
    WIDGET_CONTROL, ev.ID, GET_VALUE=val
    if (ev.ID eq dataset1) then basenr=1
    if (ev.ID eq dataset2) then basenr=2
;    if (ev.ID eq dataset3) then basenr=3
    if (ev.ID eq dataset1) then WIDGET_CONTROL, label0, $
        SET_VALUE='Current database selection: betaGRID'
    if (ev.ID eq dataset2) then WIDGET_CONTROL, label0, $
        SET_VALUE='Current database selection: DENT grid'
;    if (ev.ID eq dataset3) then WIDGET_CONTROL, label0, $
;        SET_VALUE='Current database selection: DENT grid'
  endif

  ; --- read button pressed ---
  if (ev.ID eq read_button) then begin
    READDATA
  endif

  ; --- select button pressed ---
  if (ev.ID eq select_button) then begin
    SELECT_DATA 
  endif

  ; --- axis selections ---
  if (ev.ID eq axisXselect) then SELECT_AXIS,"x" 
  if (ev.ID eq axisYselect) then SELECT_AXIS,"y" 
  if (ev.ID eq axisZselect) then SELECT_AXIS,"z" 
  if (ev.ID eq axisColours) then SELECT_COLOURS 
  if (ev.ID eq axisFilters) then SELECT_FILTERS

  ; --- load observations button pressed ---
  if (ev.ID eq load_OBS) then begin
    filename=DIALOG_PICKFILE(/READ, FILTER='*.dat')
    if (filename NE '') then begin
      WIDGET_CONTROL, label4, SET_VALUE=filename
      LOAD_OBSERVATIONS, filename,Nobs,Ncont,Nline,lamobs,Fnuobs,$
                         linenameobs, Flineobs,$
                         sigmaFnu,sigmaFl,bemcont,bemline
    endif
  endif

  ; --- fit OBS button pressed ---
  if (ev.ID eq fit_OBS) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    if (Nmod*Nobs GT 0) then begin
      FIT_OBS, dist
    endif else begin
      print,"... first read the models and load your observations!"
    endelse  
  endif

  ; --- plot MODELS selected from Menu ---
  if (ev.ID eq plot2D) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    PLOT2D_MODELS,dist
  endif
  if (ev.ID eq means2D) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    PLOT_MEANS,dist
  endif
  if (ev.ID eq contour2D) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    CONTOUR_MEANS,dist
  endif
  if (ev.ID eq plotHist) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    PLOT_HISTOGRAM,dist
  endif
  if (ev.ID eq contourMod) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    CONTOUR_MODELS,dist
  endif
  if (ev.ID eq plot3D) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    PLOT3D_MODELS
  endif

  ; --- ps and dat output selected from Menu
  if (ev.ID eq writeps) then begin
    if (pswrite) then begin
      WIDGET_CONTROL, writeps, SET_BUTTON=0
      pswrite=0
    endif else begin
      WIDGET_CONTROL, writeps, /SET_BUTTON
      pswrite=1
    endelse
  endif
  if (ev.ID eq writedat) then begin
    if (datwrite) then begin
      WIDGET_CONTROL, writedat, SET_BUTTON=0
      datwrite=0
    endif else begin
      WIDGET_CONTROL, writedat, /SET_BUTTON
      datwrite=1
    endelse
  endif

  ; --- clear plot windows selected from menu
  if (ev.ID eq closeAll) then begin
    for i=0,99 do begin
      if (Wlist(i) NE 0) then WIDGET_CONTROL, Wlist(i), /DESTROY
    endfor
  endif    
  
  ; --- plot SED button pressed ---
  if (ev.ID eq plot_SED) then begin
    seltext=WIDGET_INFO(combo_dist,/COMBOBOX_GETTEXT)
    reads,seltext,dist
    if (ID_best(0) GT -1) then begin
      PLOT_SED, dist,incl1,Nlam,lamcont,Fcont,Nobs,lamobs,Fnuobs
    endif else begin
      print,"... first define your model selection or fit SED!"
    endelse  
  endif

  ; --- save GIF button pressed ---
  if (ev.ID eq save_gif) then begin
    SAVE_GIF
  endif

  ; --- selection of parameters ---
  selected=""
  if (ev.ID eq combo_age)     then selected='age'
  if (ev.ID eq combo_Mstar)   then selected='Mstar'
  if (ev.ID eq combo_Teff)    then selected='Teff'
  if (ev.ID eq combo_Lstar)   then selected='Lstar'
  if (ev.ID eq combo_fUV)     then selected='fUV'
  if (ev.ID eq combo_Mdisk)   then selected='Mgas'
  if (ev.ID eq combo_Mdust)   then selected='Mdust'
  if (ev.ID eq combo_dustgas) then selected='dust/gas'
  if (ev.ID eq combo_Rin)     then selected='Rin'
  if (ev.ID eq combo_Rout)    then selected='Rout'
  if (ev.ID eq combo_H0)      then selected='H0'
  if (ev.ID eq combo_epsilon) then selected='epsilon'
  if (ev.ID eq combo_beta)    then selected='beta'
  if (ev.ID eq combo_amin)    then selected='amin'
  if (ev.ID eq combo_amax)    then selected='amax'
  if (ev.ID eq combo_apow)    then selected='apow'
  if (ev.ID eq combo_settle)  then selected='settle'
  if (ev.ID eq combo_dist)    then selected='dist'
  if (ev.ID eq combo_incl)    then selected='incl'
  if (ev.ID eq combo_igas)    then selected='igas'

  if ((ev.ID GE combo_Mstar) AND (ev.ID LE combo_incl)) then begin
    if (ev.index EQ -1) then begin     ; value not in list
      WIDGET_CONTROL, ev.ID, GET_VALUE=newList
      newList(N_ELEMENTS(newlist)-1) = ev.str
      WIDGET_CONTROL, ev.ID, SET_VALUE=newList
      WIDGET_CONTROL, ev.ID, SET_COMBOBOX_SELECT=N_Elements(newList)-1
    endif
    print,"parameter ",selected," changed to ",ev.str
  endif  
  ;if (ev.ID EQ text_ID)
END  



;--------------------------------------------------------------
; ***  Create the widget and registers it with the XMANAGER ***  
;--------------------------------------------------------------  
PRO xDENT

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3, $
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  COMMON selection, sel_models,sel_SEDs,sel_lines
  COMMON fits, ID_best,gas_best,incl1_best,incl2_best,chi_best 
  COMMON SEDplot, Nplotted,Fmin,Fmax 
  COMMON output, pswrite, datwrite
  COMMON window, Wlist

  varname = ["none"]
  filtername = ["none"]
  Nvars = 1

  Nmod  = 0
  Nobs  = 0
  Ncont = 0
  Nline = 0
  Nplotted = 0
  basenr = 2
  ID_best    = lonarr(10)
  gas_best   = intarr(10)
  incl1_best = intarr(10)
  incl2_best = intarr(10)
  chi_best   = fltarr(10)
  ID_best(*) = -1
  xvar1 = "none"
  xvar2 = "none"
  yvar1 = "none"
  yvar2 = "none"
  zvar1 = "none"
  zvar2 = "none"
  cname1 = "none"
  cname2 = "none"
  xminval="auto"
  xmaxval="auto"
  yminval="auto"
  ymaxval="auto"
  zminval="auto"
  zmaxval="auto"
  cminval="auto"
  cmaxval="auto"
  xlog = 1
  ylog = 1
  zlog = 1
  clog = 1
  ncolour = 8
  fvar1 = "none"
  fvar2 = "none"
  fvar3 = "none"
  fvar4 = "none"
  fmin1 = "auto"
  fmax1 = "auto"
  fmin2 = "auto"
  fmax2 = "auto"
  fmin3 = "auto"
  fmax3 = "auto"
  fmin4 = "auto"
  fmax4 = "auto"
  openr,1,"asave.xdent",ERROR=ERR  
  if (ERR EQ 0) then begin
    print,"reading last axis-selection ..." 
    readf,1,xvar1
    readf,1,xvar2
    readf,1,xlog
    readf,1,yvar1
    readf,1,yvar2
    readf,1,ylog
    readf,1,cname1
    readf,1,cname2
    readf,1,clog
    readf,1,xminval
    readf,1,xmaxval
    readf,1,yminval
    readf,1,ymaxval
    readf,1,zminval
    readf,1,zmaxval
    readf,1,cminval
    readf,1,cmaxval
    readf,1,ncolour
    readf,1,fvar1
    readf,1,fvar2
    readf,1,fvar3
    readf,1,fvar4
    readf,1,fmin1
    readf,1,fmax1
    readf,1,fmin2
    readf,1,fmax2
    readf,1,fmin3
    readf,1,fmax3
    readf,1,fmin4
    readf,1,fmax4
    close,1
  endif  

  ; Create the top-level base for the widget:  
  base = WIDGET_BASE(TITLE=' xDENT v1.1', MBAR=menubar)    

  ;im1 = READ_IMAGE('blank.jpg')
  ;im2 = Transpose(im1, [1,2,0])
  ;ok=Query_Image('blank.jpg',info)
  ;surface = WIDGET_DRAW(base,RETAIN=2,XSIZE=520,YSIZE=430)
  ;WIDGET_CONTROL, surface, /Realize
  ;WIDGET_CONTROL, surface, Get_Value=wid
  ;WSET, wid
  ;DEVICE,DECOMPOSED=0  
  ;tv,im2[*,*,0:2],TRUE=3

  ; create buttons
  ysh = 15
  read_button  = WIDGET_BUTTON(base, VALUE='read data', UVALUE= 'read', $
                              XOFFSET=10, YOFFSET=5+17, XSIZE=75, YSIZE=47)  
  select_button= WIDGET_BUTTON(base, VALUE='select', UVALUE= 'select', $
                              XOFFSET=446, YOFFSET=224+ysh,XSIZE=65, YSIZE=35)
  load_OBS     = WIDGET_BUTTON(base, VALUE='load OBS',UVALUE= 'load OBS', $
                              XOFFSET=10, YOFFSET=286, XSIZE=65, YSIZE=35)  
  fit_OBS      = WIDGET_BUTTON(base, VALUE='fit OBS', UVALUE= 'fit OBS', $
                              XOFFSET=446, YOFFSET=286,XSIZE=65, YSIZE=35)  
  plot_SED     = WIDGET_BUTTON(base, VALUE='plot SED',UVALUE= 'plot SED', $
                              XOFFSET=446, YOFFSET=333, XSIZE=65, YSIZE=35)  
  save_gif     = WIDGET_BUTTON(base, VALUE='save GIF',UVALUE= 'save GIF', $
                              XOFFSET=446, YOFFSET=380, XSIZE=65, YSIZE=35)  

  ;image1 = READ_IMAGE('GASPSlogo.jpg')
  image1 = READ_IMAGE('Logo_DIANA.jpg')
  image2 = Transpose(image1, [1,2,0])
  ;ok=Query_Image('GASPSlogo.jpg',info)
  ok=Query_Image('Logo_DIANA.jpg',info)
  ;Help,info,/STRUCTURE 
  ;WINDOW,XSIZE=info.dimensions[0],YSIZE=info.dimensions[1]
  ;TVLCT,rr,gg,bb
  ;window,xsize=1163,ysize=1168
  ;TV, image2[*,*,0:2], TRUE=3
  ;READ_JPEG,'GASPSlogo.jpg',GASPSlogo
  ;WINDOW,xsize=71,ysize=71
  ;TV,GASPSlogo,/true
  ;WRITE_BMP, 'GASPSlogo.bmp', TVRD() 
  ;GASPSlogo = READ_BMP('GASPSlogo.bmp',/RGB)  
  ;GASPSbutton = WIDGET_BUTTON(base, VALUE=image2[*,*,0:2], $
  ;                   FRAME=0, XOFFSET=440, YOFFSET=1, $
  ;                   XSIZE=info.dimensions[0],YSIZE=info.dimensions[1]) 
  GASPSbutton = WIDGET_BUTTON(base, VALUE=image2[*,*,0:2], $
                     FRAME=0, XOFFSET=402, YOFFSET=1, $
                     XSIZE=info.dimensions[0],YSIZE=info.dimensions[1]) 

  ; create model info lines

  label0 = WIDGET_LABEL(base, VALUE='Current database selection: DENT grid', $
                      XOFFSET=010, YOFFSET=2, /ALIGN_LEFT)
  label1 = WIDGET_LABEL(base, VALUE='0000000 disk models,', $
                      XOFFSET=090, YOFFSET=5+17, /ALIGN_LEFT)
  label2 = WIDGET_LABEL(base, VALUE='0000000 SEDs,', $
                      XOFFSET=090, YOFFSET=20+17, /ALIGN_LEFT)
  label3 = WIDGET_LABEL(base, VALUE='0000000 line fluxes', $
                      XOFFSET=090, YOFFSET=35+17, /ALIGN_LEFT)

  label4 = WIDGET_LABEL(base, VALUE='my .dat-file'$
                      +'                                     ', $
                      XOFFSET=80, YOFFSET=295, /ALIGN_LEFT)


  ; create comboboxes for parameters

  ; =========================================================

  ; --- 1. Mstar ---
  label5 = WIDGET_LABEL(base, VALUE='Mstar[Msun]', $
                      XOFFSET=20, YOFFSET=60+ysh, /ALIGN_LEFT)
  combo_Mstar = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=10, YOFFSET=77+ysh,SCR_XSIZE=100)

  ; --- 2. age ---
  label6 = WIDGET_LABEL(base, VALUE='age[Myr]', $
                      XOFFSET=120, YOFFSET=60+ysh, /ALIGN_LEFT)
  combo_age = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=110, YOFFSET=77+ysh,SCR_XSIZE=100)

  ; --- 3. Teff ---
  label7 = WIDGET_LABEL(base, VALUE='Teff[K]', $
                      XOFFSET=220, YOFFSET=60+ysh, /ALIGN_LEFT)
  combo_Teff = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=210, YOFFSET=77+ysh,SCR_XSIZE=100)

  ; --- 4. Lstar ---
  label8 = WIDGET_LABEL(base, VALUE='Lstar[Lsun]', $
                      XOFFSET=320, YOFFSET=60+ysh, /ALIGN_LEFT)
  combo_Lstar = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=310, YOFFSET=77+ysh,SCR_XSIZE=100)

  ; --- 5. fUV ---
  label9 = WIDGET_LABEL(base, VALUE='fUV[-]', $
                      XOFFSET=420, YOFFSET=60+ysh, /ALIGN_LEFT)
  combo_fUV = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=410, YOFFSET=77+ysh,SCR_XSIZE=100)

; =========================================================

  ; --- 6. Mdisk ---
  label10 = WIDGET_LABEL(base, VALUE='Mgas[Msun]', $
                      XOFFSET=20, YOFFSET=110+ysh, /ALIGN_LEFT)
  combo_Mdisk = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=10, YOFFSET=127+ysh,SCR_XSIZE=100)

  ; --- 7. Mdust ---
  label11 = WIDGET_LABEL(base, VALUE='Mdust[Msun]', $
                      XOFFSET=120, YOFFSET=110+ysh, /ALIGN_LEFT)
  combo_Mdust = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=110, YOFFSET=127+ysh,SCR_XSIZE=100)

  ; --- 8. dust/gas ---
  label11 = WIDGET_LABEL(base, VALUE='dust/gas[-]', $
                      XOFFSET=220, YOFFSET=110+ysh, /ALIGN_LEFT)
  combo_dustgas = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=210, YOFFSET=127+ysh,SCR_XSIZE=100)

  ; --- 9. Rin ---
  label12 = WIDGET_LABEL(base, VALUE='Rin[AU]     ', $
                      XOFFSET=320, YOFFSET=110+ysh, /ALIGN_LEFT)
  combo_Rin = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=310, YOFFSET=127+ysh,SCR_XSIZE=100)

  ; --- 10. Rout ---
  label13 = WIDGET_LABEL(base, VALUE='Rout[AU]', $
                      XOFFSET=420, YOFFSET=110+ysh, /ALIGN_LEFT)
  combo_Rout = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=410, YOFFSET=127+ysh,SCR_XSIZE=100)

  ;============================================================

  ; --- 11. H0 ---
  label14 = WIDGET_LABEL(base, VALUE='H0[AU]', $
                      XOFFSET=20, YOFFSET=210+ysh, /ALIGN_LEFT)
  combo_H0 = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=10, YOFFSET=227+ysh,SCR_XSIZE=100)

  ; --- 12. epsilon ---
  label15 = WIDGET_LABEL(base, VALUE='epsilon[-]', $
                      XOFFSET=120, YOFFSET=210+ysh, /ALIGN_LEFT)
  combo_epsilon = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=110, YOFFSET=227+ysh,SCR_XSIZE=100)

  ; --- 13. beta ---
  label16 = WIDGET_LABEL(base, VALUE='beta[-]', $
                      XOFFSET=220, YOFFSET=210+ysh, /ALIGN_LEFT)
  combo_beta = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=210, YOFFSET=227+ysh,SCR_XSIZE=100)

; =========================================================

  ; --- 14. amin ---
  label17 = WIDGET_LABEL(base, VALUE='amin[mic]', $
                      XOFFSET=20, YOFFSET=160+ysh, /ALIGN_LEFT)
  combo_amin = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=10, YOFFSET=177+ysh,SCR_XSIZE=100)

  ; --- 15. amax ---
  label18 = WIDGET_LABEL(base, VALUE='amax[mic]', $
                      XOFFSET=120, YOFFSET=160+ysh, /ALIGN_LEFT)
  combo_amax = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=110, YOFFSET=177+ysh,SCR_XSIZE=100)

  ; --- 15a. apow ---
  label18a = WIDGET_LABEL(base, VALUE='apow[-]', $
                      XOFFSET=220, YOFFSET=160+ysh, /ALIGN_LEFT)
  combo_apow = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=210, YOFFSET=177+ysh,SCR_XSIZE=100)

  ; --- 16. settle ---
  label19 = WIDGET_LABEL(base, VALUE='settle[-]', $
                      XOFFSET=320, YOFFSET=160+ysh, /ALIGN_LEFT)
  combo_settle = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=310, YOFFSET=177+ysh,SCR_XSIZE=100)


; =========================================================

  ; --- 17. distance ---
  label20 = WIDGET_LABEL(base, VALUE='distance[pc]', $
                      XOFFSET=10, YOFFSET=320+ysh, /ALIGN_LEFT)
  combo_dist = Widget_Combobox(base,/EDIT, $
           VALUE=['140','input'], $
           XOFFSET=10, YOFFSET=337+ysh,SCR_XSIZE=100)

  ; --- 18. inclination ---
  label21 = WIDGET_LABEL(base, VALUE='inclination[deg]', $
                      XOFFSET=110, YOFFSET=320+ysh, /ALIGN_LEFT)
  combo_incl = Widget_Combobox(base,/EDIT, $
           VALUE=['all','input'], $
           XOFFSET=110, YOFFSET=337+ysh,SCR_XSIZE=100)

  ; --- individual model ID selection ---
  label22 = WIDGET_LABEL(base, VALUE='model ID',XOFFSET=252,YOFFSET=320+ysh, $
                         /ALIGN_LEFT)
  text_ID = WIDGET_TEXT(base,/EDITABLE, XOFFSET=250,YOFFSET=337+ysh,$
                        SCR_XSIZE=60,VALUE='all')
  label23 = WIDGET_LABEL(base, VALUE='igas',XOFFSET=330,YOFFSET=320+ysh)
  combo_igas = WIDGET_COMBOBOX(base, /EDIT,VALUE=['all','input'], XOFFSET=320,$
                               YOFFSET=337+ysh,SCR_XSIZE=70,SCR_YSIZE=30)

  ;==========================================================
  ; create the menu
  ;==========================================================
  fileMenu    = WIDGET_BUTTON(menubar,  VALUE='File', /MENU)
  fileSelect  = WIDGET_BUTTON(fileMenu, VALUE='Select database...',/MENU)
  dataset1    = WIDGET_BUTTON(fileSelect, VALUE='betaGRID',/CHECKED_MENU)
  dataset2    = WIDGET_BUTTON(fileSelect, VALUE='DENT grid',/CHECKED_MENU)
;  dataset3    = WIDGET_BUTTON(fileSelect, VALUE='DENT grid',/CHECKED_MENU)
  fileExit    = WIDGET_BUTTON(fileMenu, VALUE='Exit')
  WIDGET_CONTROL, dataset2, /SET_BUTTON

  axisMenu    = WIDGET_BUTTON(menubar,  VALUE='Axis', /MENU)
  axisXselect = WIDGET_BUTTON(axisMenu, VALUE='select x-axis ...')
  axisYselect = WIDGET_BUTTON(axisMenu, VALUE='select y-axis ...')
  axisZselect = WIDGET_BUTTON(axisMenu, VALUE='select z-axis ...')
  axisColours = WIDGET_BUTTON(axisMenu, VALUE='colour coding ...')
  axisFilters = WIDGET_BUTTON(axisMenu, VALUE='filter values ...')

  plotMenu    = WIDGET_BUTTON(menubar,  VALUE='Plotting', /MENU)
  plot2D      = WIDGET_BUTTON(plotMenu, VALUE='plot points')
  contourMod  = WIDGET_BUTTON(plotMenu, VALUE='encircle models')
  means2D     = WIDGET_BUTTON(plotMenu, VALUE='plot means')
  contour2D   = WIDGET_BUTTON(plotMenu, VALUE='contour means')
  plotHist    = WIDGET_BUTTON(plotMenu, VALUE='histogram')
  plot3D      = WIDGET_BUTTON(plotMenu, VALUE='3D-plot')
  writedat    = WIDGET_BUTTON(plotMenu, VALUE='nice .ps output?',/CHECKED_MENU)
  writeps     = -1

  windowMenu  = WIDGET_BUTTON(menubar,   VALUE='Window', /MENU)
  closeAll    = WIDGET_BUTTON(windowMenu,VALUE='clear plot windows')
  

  pswrite  = 0
  datwrite = 0
  Wlist  = intarr(100)

  ; Realize the widget (i.e., display it on screen):  
  WIDGET_CONTROL, base, SCR_XSIZE=520, SCR_YSIZE=430, /REALIZE  

  ; Register the widget with the XMANAGER, leaving the IDL command   
  ; line active:  
  XMANAGER, 'xDENT', base, /NO_BLOCK  
END  

;-----------------------
; ***  main program  ***
;-----------------------
xDENT
END
